VERSION 5.00
Begin VB.Form frmCoorConv 
   Caption         =   "Toolbox 1 - Coordinate Conversion and Latitude "
   ClientHeight    =   5550
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6585
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmCoorConv.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5550
   ScaleWidth      =   6585
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdLatToInc 
      Height          =   495
      Left            =   2520
      Picture         =   "frmCoorConv.frx":0442
      Style           =   1  'Graphical
      TabIndex        =   23
      Top             =   4920
      Width           =   1695
   End
   Begin VB.CommandButton cmdIncToLat 
      Height          =   495
      Left            =   2520
      Picture         =   "frmCoorConv.frx":0884
      Style           =   1  'Graphical
      TabIndex        =   22
      Top             =   4320
      Width           =   1695
   End
   Begin VB.TextBox txtLatitude 
      Height          =   375
      Left            =   4560
      TabIndex        =   21
      Top             =   4800
      Width           =   1935
   End
   Begin VB.TextBox txtInclination2 
      Height          =   375
      Left            =   120
      TabIndex        =   20
      Top             =   4800
      Width           =   2055
   End
   Begin VB.TextBox txtDigits 
      Alignment       =   1  'Right Justify
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   5880
      TabIndex        =   15
      Text            =   "5"
      Top             =   1920
      Width           =   615
   End
   Begin VB.CommandButton cmdCarttoSphe 
      Caption         =   "x1, x2, x3 to D, I, M"
      Height          =   855
      Left            =   2280
      Picture         =   "frmCoorConv.frx":0CC6
      Style           =   1  'Graphical
      TabIndex        =   13
      Top             =   1680
      Width           =   2055
   End
   Begin VB.CommandButton cmdSphetoCart 
      Caption         =   "D, I, M to x1, x2, x3"
      Height          =   855
      Left            =   120
      MaskColor       =   &H00808080&
      Picture         =   "frmCoorConv.frx":1108
      Style           =   1  'Graphical
      TabIndex        =   12
      Top             =   1680
      UseMaskColor    =   -1  'True
      Width           =   2055
   End
   Begin VB.TextBox txtDown 
      Height          =   390
      Left            =   4440
      TabIndex        =   11
      Top             =   3000
      Width           =   2000
   End
   Begin VB.TextBox txtEast 
      Height          =   390
      Left            =   2280
      TabIndex        =   10
      Top             =   3000
      Width           =   2000
   End
   Begin VB.TextBox txtNorth 
      Height          =   390
      Left            =   120
      TabIndex        =   9
      Top             =   3000
      Width           =   2000
   End
   Begin VB.TextBox txtIntensity 
      Height          =   390
      Left            =   4440
      TabIndex        =   8
      Top             =   1080
      Width           =   2000
   End
   Begin VB.TextBox txtInclination 
      Height          =   390
      Left            =   2280
      TabIndex        =   7
      Top             =   1080
      Width           =   2000
   End
   Begin VB.TextBox txtDeclination 
      Height          =   390
      Left            =   120
      TabIndex        =   6
      Top             =   1080
      Width           =   2000
   End
   Begin VB.Label lblLatitude 
      Alignment       =   2  'Center
      Caption         =   "Latitude (degree)"
      Height          =   255
      Left            =   4440
      TabIndex        =   19
      Top             =   4440
      Width           =   2055
   End
   Begin VB.Label lblInclination2 
      Alignment       =   2  'Center
      Caption         =   "Inclination (degree)"
      Height          =   255
      Left            =   120
      TabIndex        =   18
      Top             =   4440
      Width           =   2175
   End
   Begin VB.Label lblIncToLatitude 
      Alignment       =   2  'Center
      Caption         =   "Conversion between Inclination and Latitude"
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   17
      Top             =   3840
      Width           =   6375
   End
   Begin VB.Label lblCoordinateConv 
      Alignment       =   2  'Center
      Caption         =   "Conversion between Spherical and Cartesian Coordinate Systems"
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   120
      TabIndex        =   16
      Top             =   0
      Width           =   6375
   End
   Begin VB.Line Line2 
      BorderColor     =   &H80000005&
      X1              =   120
      X2              =   6480
      Y1              =   3630
      Y2              =   3630
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   6480
      Y1              =   3600
      Y2              =   3600
   End
   Begin VB.Label lblDigits 
      Alignment       =   2  'Center
      Caption         =   "Digits after decimal point"
      Height          =   495
      Left            =   4440
      TabIndex        =   14
      Top             =   1920
      Width           =   1335
   End
   Begin VB.Label lblDown 
      Alignment       =   2  'Center
      Caption         =   "Down (x3)"
      Height          =   255
      Left            =   4680
      TabIndex        =   5
      Top             =   2640
      Width           =   1575
   End
   Begin VB.Label lblEast 
      Alignment       =   2  'Center
      Caption         =   "East (x2)"
      Height          =   255
      Left            =   2520
      TabIndex        =   4
      Top             =   2640
      Width           =   1575
   End
   Begin VB.Label lblNorth 
      Alignment       =   2  'Center
      Caption         =   "North(x1)"
      Height          =   255
      Left            =   360
      TabIndex        =   3
      Top             =   2640
      Width           =   1575
   End
   Begin VB.Label lblIntensity 
      Alignment       =   2  'Center
      Caption         =   "Intensity"
      Height          =   255
      Left            =   4440
      TabIndex        =   2
      Top             =   720
      Width           =   1935
   End
   Begin VB.Label lblInclination 
      Alignment       =   2  'Center
      Caption         =   "Inclination (degree)"
      Height          =   255
      Left            =   2280
      TabIndex        =   1
      Top             =   720
      Width           =   1935
   End
   Begin VB.Label lblDeclination 
      Alignment       =   2  'Center
      Caption         =   "Declination (degree)"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   720
      Width           =   1935
   End
End
Attribute VB_Name = "frmCoorConv"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private digits As Integer
Private DigitFormat As String

Private Sub cmdCartToSphe_Click()
    Dim Declination, Inclination, Intensity As Double
    Dim North, East, Down As Double
    Dim I As Integer
       
    If IsNumeric(txtDigits.Text) = False Then
        Call MsgBox("Please input an integer for digits", vbOKOnly, "Digits for display")
        Call txtDigits.SetFocus
        Exit Sub
    Else
        digits = txtDigits.Text
        DigitFormat = "0."
        For I = 1 To digits
            DigitFormat = DigitFormat & "0"
        Next I
    End If
    
    If txtNorth.Text = "" Or (IsNumeric(txtNorth.Text) = False) Then
        Call MsgBox("Please input a valid number for the North (x1) component", vbOKOnly, "Input North (x1) Component")
        Call txtNorth.SetFocus
        Exit Sub
    ElseIf txtEast.Text = "" Or (IsNumeric(txtEast.Text) = False) Then
        Call MsgBox("Please input a valid number for the East (x2) component", vbOKOnly, "Input East (x2) Component")
        Call txtEast.SetFocus
        Exit Sub
    ElseIf txtDown.Text = "" Or (IsNumeric(txtDown.Text) = False) Then
        Call MsgBox("Please input a valid number for the Down (x3) component", vbOKOnly, "Input Down (x3) Component")
        Call txtDown.SetFocus
        Exit Sub
    End If
    
    North = CDbl(txtNorth.Text)
    East = CDbl(txtEast.Text)
    Down = CDbl(txtDown.Text)
    
    Intensity = Sqr(North ^ 2 + East ^ 2 + Down ^ 2)
    Declination = ArcTan(North, East)
    If Sqr(North ^ 2 + East ^ 2) < 0.000001 Then
        If Down >= 0 Then
            Inclination = PI / 2
        Else
            Inclination = -PI / 2
        End If
    Else
        Inclination = Atn(Down / Sqr(North ^ 2 + East ^ 2))
    End If
    
    txtDeclination.Text = Format(RadToDeg(Declination), DigitFormat)
    txtInclination.Text = Format(RadToDeg(Inclination), DigitFormat)
    txtIntensity.Text = Format(Intensity, DigitFormat)
End Sub

Private Sub cmdIncToLat_Click()
    Dim Inclination2 As Single
    Dim Latitude As Single
    
    If txtInclination2.Text = "" Or IsNumeric(txtInclination2.Text) = False Then
        Call MsgBox("Please input an valid inclination", vbOKOnly, "Input inclination")
        Call txtInclination2.SetFocus
        Exit Sub
    ElseIf CSng(txtInclination2.Text) < -90 Or CSng(txtInclination2.Text) > 90 Then
        Call MsgBox("Please input a valid Inclination: -90 to 90 degree", vbOKOnly, "Input Inclination")
        Call txtInclination2.SetFocus
        Exit Sub
    End If
    
    Inclination2 = CSng(txtInclination2.Text)
    If Inclination2 = 90 Then
        Latitude = PI / 2
    ElseIf Inclination2 = -90 Then
        Latitude = -PI / 2
    Else
        Latitude = Atn(Tan(DegToRad(Inclination2)) / 2)
    End If
    
    txtLatitude.Text = Format(RadToDeg(Latitude), "0.00")
End Sub

Private Sub cmdLatToInc_Click()
    Dim Inclination2 As Single
    Dim Latitude As Single
    
    If txtLatitude.Text = "" Or IsNumeric(txtLatitude.Text) = False Then
        Call MsgBox("Please input a valid Latitude", vbOKOnly, "Input Latitude")
        Call txtLatitude.SetFocus
        Exit Sub
    ElseIf CSng(txtLatitude.Text) < -90 Or CSng(txtLatitude.Text) > 90 Then
        Call MsgBox("Please input a valid Latitude: -90 to 90 degree", vbOKOnly, "Input Latitude")
        Call txtLatitude.SetFocus
        Exit Sub
    End If
    
    Latitude = CSng(txtLatitude.Text)
    If Latitude = 90 Then
        Inclination2 = PI / 2
    ElseIf Latitude = -90 Then
        Inclination2 = -PI / 2
    Else
        Inclination2 = Atn(2 * Tan(DegToRad(Latitude)))
    End If
    
    txtInclination2.Text = Format(RadToDeg(Inclination2), "0.00")
End Sub

Private Sub cmdSpheToCart_Click()
    Dim Declination, Inclination, Intensity As Double
    Dim North, East, Down As Double
    Dim I As Integer
    
    txtNorth.Text = ""
    txtEast.Text = ""
    txtDown.Text = ""
    
    If IsNumeric(txtDigits.Text) = False Then
        Call MsgBox("Please input an integer for digits", vbOKOnly, "Digits for display")
        Call txtDigits.SetFocus
        Exit Sub
    Else
        digits = txtDigits.Text
        DigitFormat = "0."
        For I = 1 To digits
            DigitFormat = DigitFormat & "0"
        Next I
    End If
    
    If txtDeclination.Text = "" Or (IsNumeric(txtDeclination.Text) = False) Then
        Call MsgBox("Please input a valid number for Declination", vbOKOnly, "Input Declination")
        Call txtDeclination.SetFocus
        Exit Sub
    ElseIf txtInclination.Text = "" Or (IsNumeric(txtInclination.Text) = False) Then
        Call MsgBox("Please input a valid number for Inclination", vbOKOnly, "Input Inclination")
        Call txtInclination.SetFocus
        Exit Sub
    ElseIf CDbl(txtInclination.Text) > 90 Or CDbl(txtInclination.Text) < -90 Then
        Call MsgBox("Please input a valid Inclination: -90 to 90 degree", vbOKOnly, "Input Inclination")
        Call txtInclination.SetFocus
        Exit Sub
    ElseIf txtIntensity.Text = "" Or (IsNumeric(txtIntensity.Text) = False) Then
        Call MsgBox("Please input a valid number for Intensity", vbOKOnly, "Input Intensity")
        Call txtIntensity.SetFocus
        Exit Sub
    End If
    
    Inclination = CDbl(txtInclination.Text)
    Declination = CDbl(txtDeclination.Text)
    Intensity = CDbl(txtIntensity.Text)
    
    North = Intensity * Cos(DegToRad(Inclination)) * Cos(DegToRad(Declination))
    East = Intensity * Cos(DegToRad(Inclination)) * Sin(DegToRad(Declination))
    Down = Intensity * Sin(DegToRad(Inclination))
    
    txtNorth.Text = Format(North, DigitFormat)
    txtEast.Text = Format(East, DigitFormat)
    txtDown.Text = Format(Down, DigitFormat)
End Sub
