VERSION 5.00
Begin VB.Form frmFileOpen 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Open *.mag File"
   ClientHeight    =   4920
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5895
   BeginProperty Font 
      Name            =   "Courier"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmFileOpen.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4920
   ScaleWidth      =   5895
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame fraFileOpen 
      Caption         =   "File Selection"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4695
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5655
      Begin VB.CommandButton cmdExit 
         Caption         =   "E&xit"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   4080
         TabIndex        =   6
         Top             =   4080
         Width           =   1335
      End
      Begin VB.CommandButton cmdCancel 
         Caption         =   "&Cancel"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   2280
         TabIndex        =   5
         Top             =   4080
         Width           =   1335
      End
      Begin VB.CommandButton cmdOpen 
         Caption         =   "&Open"
         Default         =   -1  'True
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   240
         TabIndex        =   4
         Top             =   4080
         Width           =   1575
      End
      Begin VB.FileListBox filPMagOpen 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   3450
         Left            =   2760
         Pattern         =   "*.mag"
         TabIndex        =   3
         Top             =   360
         Width           =   2655
      End
      Begin VB.DirListBox dirPMagOpen 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   2790
         Left            =   240
         TabIndex        =   2
         Top             =   960
         Width           =   2295
      End
      Begin VB.DriveListBox drvPMagOpen 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   360
         Left            =   240
         TabIndex        =   1
         Top             =   360
         Width           =   2295
      End
   End
End
Attribute VB_Name = "frmFileOpen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private OpenFileName As String

Private Sub cmdCancel_Click()
    Unload frmFileOpen
    Call frmMain.Show
End Sub

Private Sub cmdExit_Click()
    Unload frmFileOpen
    Unload frmMain
End Sub

Public Sub cmdOpen_Click()
    'Get *.mag file to open, and pass the filename to frmMain
    OpenFileName = CorrectFileName(filPMagOpen.Path, filPMagOpen.FileName)
    Unload frmFileOpen
    Call frmMain.GetOpenFileName(OpenFileName)
    Call frmMain.Show
End Sub

'Purpose:   Update the DirListBox's path with the new drive
'       letter from the DriveListBox.
Private Sub drvPMagOpen_Change()
    dirPMagOpen.Path = drvPMagOpen.Drive
End Sub

'Purpose:   Update the FileListBox's path with the new value
'       of the DirListBox's path.
Private Sub dirPMagOpen_Change()
    filPMagOpen.Path = dirPMagOpen.Path
End Sub

Private Sub filPMagOpen_DblClick()
    cmdOpen_Click
End Sub

Private Sub Form_Load()
    Call drvPMagOpen_Change
    Call dirPMagOpen_Change
End Sub
