VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmProjections 
   AutoRedraw      =   -1  'True
   Caption         =   "Toolbox 2 - Various Projections"
   ClientHeight    =   7830
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   12690
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmProjections.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   7830
   ScaleWidth      =   12690
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fraVGP 
      Caption         =   "Virtual Geomagnetic Pole (VGP)"
      Height          =   1710
      Left            =   8160
      TabIndex        =   85
      Top             =   6000
      Width           =   4455
      Begin VB.TextBox txtDM 
         Height          =   375
         Left            =   3180
         Locked          =   -1  'True
         TabIndex        =   98
         Top             =   1200
         Width           =   1200
      End
      Begin VB.TextBox txtDP 
         Height          =   375
         Left            =   1920
         Locked          =   -1  'True
         TabIndex        =   97
         Top             =   1200
         Width           =   1200
      End
      Begin VB.CommandButton cmdVGPToSampleDecInc 
         Height          =   615
         Left            =   120
         Picture         =   "frmProjections.frx":0442
         Style           =   1  'Graphical
         TabIndex        =   91
         ToolTipText     =   "Knowing VGP and Sample Latitude and Longitude, calculate the Declination and Inclination at the sample site."
         Top             =   960
         Width           =   1695
      End
      Begin VB.CommandButton cmdVGPCalculate 
         Caption         =   "Calculate &VGP"
         Height          =   615
         Left            =   120
         TabIndex        =   90
         ToolTipText     =   "Need Site Latitude and Longitude (in VGP Ellipse Projection) and Fisher Analysis results (Declination, Inclination, etc.)"
         Top             =   360
         Width           =   1695
      End
      Begin VB.TextBox txtVGPPoleLong 
         Height          =   375
         Left            =   3180
         TabIndex        =   87
         Top             =   480
         Width           =   1200
      End
      Begin VB.TextBox txtVGPPoleLat 
         Height          =   375
         Left            =   1920
         TabIndex        =   86
         Top             =   480
         Width           =   1200
      End
      Begin VB.Label lblDM 
         Alignment       =   2  'Center
         Caption         =   "DM (/Long)"
         Height          =   255
         Left            =   3180
         TabIndex        =   96
         Top             =   960
         Width           =   1200
      End
      Begin VB.Label lblDP 
         Alignment       =   2  'Center
         Caption         =   "DP (/Lat)"
         Height          =   255
         Left            =   1920
         TabIndex        =   95
         Top             =   960
         Width           =   1200
      End
      Begin VB.Label lblVGPPoleLong 
         Alignment       =   2  'Center
         Caption         =   "VGP Long."
         Height          =   255
         Left            =   3180
         TabIndex        =   89
         Top             =   240
         Width           =   1200
      End
      Begin VB.Label lblVGPPoleLat 
         Alignment       =   2  'Center
         Caption         =   "VGP Lat."
         Height          =   255
         Left            =   1920
         TabIndex        =   88
         Top             =   240
         Width           =   1200
      End
   End
   Begin VB.Frame fraFisher 
      Caption         =   "Fisher Analysis"
      Height          =   1695
      Left            =   8160
      TabIndex        =   71
      Top             =   4200
      Width           =   4455
      Begin VB.TextBox txtSignificanceLevel 
         Height          =   375
         Left            =   3720
         TabIndex        =   72
         Text            =   "0.05"
         Top             =   360
         Width           =   615
      End
      Begin VB.TextBox txtK 
         Height          =   375
         Left            =   3600
         TabIndex        =   78
         Top             =   1200
         Width           =   735
      End
      Begin VB.TextBox txtFisherDec 
         Height          =   375
         Left            =   120
         TabIndex        =   75
         Top             =   1200
         Width           =   1095
      End
      Begin VB.TextBox txtFisherInc 
         Height          =   375
         Left            =   1320
         TabIndex        =   76
         Top             =   1200
         Width           =   1095
      End
      Begin VB.TextBox txtAlpha95 
         Height          =   375
         Left            =   2520
         TabIndex        =   77
         Top             =   1200
         Width           =   975
      End
      Begin VB.CommandButton cmdFisher 
         Caption         =   "&Fisher Analysis"
         Height          =   375
         Left            =   120
         TabIndex        =   79
         ToolTipText     =   $"frmProjections.frx":0884
         Top             =   360
         Width           =   1695
      End
      Begin VB.Label lblK 
         Alignment       =   2  'Center
         Caption         =   "k"
         Height          =   255
         Left            =   3600
         TabIndex        =   84
         Top             =   960
         Width           =   735
      End
      Begin VB.Label lblSignificanceLevel 
         Alignment       =   1  'Right Justify
         Caption         =   "Significance Level (= 1 - Confid. Level)"
         Height          =   495
         Left            =   1920
         TabIndex        =   83
         Top             =   270
         Width           =   1695
      End
      Begin VB.Label lblFisherDec 
         Alignment       =   2  'Center
         Caption         =   "Declination"
         Height          =   255
         Left            =   120
         TabIndex        =   82
         Top             =   960
         Width           =   1095
      End
      Begin VB.Label lblFisherInc 
         Alignment       =   2  'Center
         Caption         =   "Inclination"
         Height          =   255
         Left            =   1320
         TabIndex        =   81
         Top             =   960
         Width           =   1095
      End
      Begin VB.Label lblAlpha95 
         Alignment       =   2  'Center
         Caption         =   "Alpha (95)"
         Height          =   255
         Left            =   2520
         TabIndex        =   80
         Top             =   960
         Width           =   975
      End
   End
   Begin VB.Frame fraEllipsePlot 
      Caption         =   "VGP Ellipse Projection"
      Height          =   3975
      Left            =   7200
      TabIndex        =   60
      Top             =   0
      Width           =   5415
      Begin VB.TextBox txtNumPoints 
         Height          =   375
         Left            =   1380
         TabIndex        =   94
         Text            =   "2000"
         Top             =   2580
         Width           =   1200
      End
      Begin VB.TextBox txtLineThickness 
         Height          =   360
         Left            =   4800
         TabIndex        =   70
         Text            =   "1"
         Top             =   1500
         Width           =   495
      End
      Begin VB.CommandButton cmdClearPlotArea 
         Caption         =   "&Clear Plot Area"
         Height          =   375
         Left            =   120
         TabIndex        =   68
         ToolTipText     =   "If you use different projections, the plot area gets messy. Use this button to clean the projection area."
         Top             =   1080
         Width           =   2580
      End
      Begin VB.CommandButton cmdPrintEllipseEQPlot 
         Caption         =   "&8. Print Ellipse EAPlot"
         Height          =   375
         Left            =   2715
         TabIndex        =   66
         ToolTipText     =   "Can print ellipse(s) onto other equal area projection."
         Top             =   720
         Width           =   2580
      End
      Begin VB.CommandButton cmdEllipseEQPlot 
         Caption         =   "&7. Ellipse E-A-Plot"
         Height          =   375
         Left            =   120
         TabIndex        =   65
         ToolTipText     =   "Can add ellipse(s) onto other equal area projection."
         Top             =   720
         Width           =   2580
      End
      Begin VB.TextBox txtLong 
         Height          =   360
         Left            =   1380
         TabIndex        =   74
         Top             =   2130
         Width           =   1200
      End
      Begin VB.TextBox txtLat 
         Height          =   360
         Left            =   120
         TabIndex        =   73
         Top             =   2130
         Width           =   1200
      End
      Begin VB.CommandButton cmdPrintEllipseSPlot 
         Caption         =   "&6. Print Ellipse S-Plot"
         Height          =   375
         Left            =   2715
         TabIndex        =   62
         ToolTipText     =   "Can print ellipse(s) onto other stereographic projection."
         Top             =   360
         Width           =   2580
      End
      Begin VB.CommandButton cmdEllipseSPlot 
         Caption         =   "&5. Ellipse S-Plot"
         Height          =   375
         Left            =   120
         TabIndex        =   61
         ToolTipText     =   "Can add ellipse(s) onto other stereographic projection."
         Top             =   360
         Width           =   2580
      End
      Begin VB.Label lblNumPoints 
         Alignment       =   1  'Right Justify
         BorderStyle     =   1  'Fixed Single
         Caption         =   "# of Points: "
         Height          =   375
         Left            =   120
         TabIndex        =   93
         Top             =   2580
         Width           =   1200
      End
      Begin VB.Label lblEllipseDataNote 
         BorderStyle     =   1  'Fixed Single
         Caption         =   "Mean Declination and Inclination, and Alpha(95) Data from text boxes in the Fisher Analysis."
         ForeColor       =   &H00008000&
         Height          =   1050
         Left            =   2640
         TabIndex        =   92
         Top             =   1920
         Width           =   2655
      End
      Begin VB.Label lblLineThickness 
         Alignment       =   1  'Right Justify
         BorderStyle     =   1  'Fixed Single
         Caption         =   "Line thickness (pixels):"
         Height          =   360
         Left            =   2640
         TabIndex        =   69
         Top             =   1500
         Width           =   2100
      End
      Begin VB.Label lblEllipsePlotNote 
         BorderStyle     =   1  'Fixed Single
         Caption         =   "Values for circle diameter, symbol color and size, and line color are from the text boxes in the Other Projections section."
         ForeColor       =   &H00FF0000&
         Height          =   855
         Left            =   120
         TabIndex        =   67
         Top             =   3000
         Width           =   5175
      End
      Begin VB.Label lblLongitude 
         Alignment       =   2  'Center
         BorderStyle     =   1  'Fixed Single
         Caption         =   "Longitude (Site;degree)"
         Height          =   540
         Left            =   1380
         TabIndex        =   64
         Top             =   1500
         Width           =   1200
      End
      Begin VB.Label lblLatitude 
         Alignment       =   2  'Center
         BorderStyle     =   1  'Fixed Single
         Caption         =   "Latitude (Site;degree)"
         Height          =   540
         Left            =   120
         TabIndex        =   63
         Top             =   1500
         Width           =   1200
      End
   End
   Begin VB.CommandButton cmdCartToSphe 
      Height          =   495
      Left            =   3720
      Picture         =   "frmProjections.frx":0921
      Style           =   1  'Graphical
      TabIndex        =   59
      Top             =   6480
      Width           =   495
   End
   Begin VB.CommandButton cmdSpheToCart 
      Height          =   495
      Left            =   3720
      Picture         =   "frmProjections.frx":0D63
      Style           =   1  'Graphical
      TabIndex        =   58
      Top             =   5640
      Width           =   495
   End
   Begin VB.TextBox txtCartData 
      Height          =   3000
      Left            =   4200
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      ToolTipText     =   "Type, or copy and paste data here. If no Down (x3) data, default to one."
      Top             =   4710
      Width           =   3855
   End
   Begin VB.Frame fraOther 
      Caption         =   "Other Projections (Use Declination, Inclination, Intensity Data)"
      Height          =   2175
      Left            =   120
      TabIndex        =   33
      Top             =   2160
      Width           =   6975
      Begin VB.CommandButton cmdPrintEqAPlot 
         Caption         =   "&4. Print E-A-Plot"
         Height          =   375
         Left            =   2520
         TabIndex        =   18
         Top             =   720
         Width           =   1575
      End
      Begin VB.CommandButton cmdPrintSPlot 
         Caption         =   "&3. Print S-Plot"
         Height          =   375
         Left            =   2520
         TabIndex        =   17
         Top             =   360
         Width           =   1575
      End
      Begin VB.Frame frmLineColor 
         Caption         =   "Line Color (Integer)"
         Height          =   855
         Left            =   4200
         TabIndex        =   42
         Top             =   1200
         Width           =   2655
         Begin VB.TextBox txtLineColorR 
            Height          =   375
            Left            =   360
            TabIndex        =   25
            Text            =   "0"
            Top             =   360
            Width           =   495
         End
         Begin VB.TextBox txtLineColorG 
            Height          =   375
            Left            =   1200
            TabIndex        =   26
            Text            =   "0"
            Top             =   360
            Width           =   495
         End
         Begin VB.TextBox txtLineColorB 
            Height          =   375
            Left            =   2040
            TabIndex        =   27
            Text            =   "255"
            Top             =   360
            Width           =   495
         End
         Begin VB.Label lblLineColorR 
            Caption         =   "R"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   120
            TabIndex        =   45
            Top             =   360
            Width           =   255
         End
         Begin VB.Label lblLineColorG 
            Caption         =   "G"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   960
            TabIndex        =   44
            Top             =   360
            Width           =   255
         End
         Begin VB.Label lblLineColorB 
            Caption         =   "B"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   1800
            TabIndex        =   43
            Top             =   360
            Width           =   255
         End
      End
      Begin VB.Frame fraSymbol 
         Caption         =   "Symbol Color and Size (Integer)"
         Height          =   855
         Left            =   120
         TabIndex        =   37
         Top             =   1200
         Width           =   3975
         Begin VB.TextBox txtSymSize 
            Height          =   375
            Left            =   3120
            TabIndex        =   24
            Text            =   "4"
            Top             =   360
            Width           =   615
         End
         Begin VB.TextBox txtSymColorB 
            Height          =   375
            Left            =   2040
            TabIndex        =   23
            Text            =   "255"
            Top             =   360
            Width           =   495
         End
         Begin VB.TextBox txtSymColorG 
            Height          =   375
            Left            =   1200
            TabIndex        =   22
            Text            =   "0"
            Top             =   360
            Width           =   495
         End
         Begin VB.TextBox txtSymColorR 
            Height          =   375
            Left            =   360
            TabIndex        =   21
            Text            =   "0"
            Top             =   360
            Width           =   495
         End
         Begin VB.Label lblSymSize 
            Caption         =   "Size"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   2640
            TabIndex        =   41
            Top             =   360
            Width           =   495
         End
         Begin VB.Label lblSymColorB 
            Caption         =   "B"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   1800
            TabIndex        =   40
            Top             =   360
            Width           =   255
         End
         Begin VB.Label lblSymColorG 
            Caption         =   "G"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   960
            TabIndex        =   39
            Top             =   360
            Width           =   255
         End
         Begin VB.Label lblSymColorR 
            Caption         =   "R"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   120
            TabIndex        =   38
            Top             =   360
            Width           =   255
         End
      End
      Begin VB.TextBox txtConnect 
         Height          =   375
         Left            =   6240
         TabIndex        =   20
         Text            =   "Yes"
         Top             =   720
         Width           =   615
      End
      Begin VB.TextBox txtDiameter 
         Height          =   375
         Left            =   6240
         TabIndex        =   19
         Text            =   "15"
         Top             =   300
         Width           =   615
      End
      Begin VB.CommandButton cmdEQPlot 
         Caption         =   "&Equal Area Projection"
         Height          =   375
         Left            =   120
         TabIndex        =   16
         Top             =   720
         Width           =   2415
      End
      Begin VB.CommandButton cmdStereoPlot 
         Caption         =   "&Stereographic Projection"
         Height          =   375
         Left            =   120
         TabIndex        =   15
         Top             =   360
         Width           =   2415
      End
      Begin VB.Label lblConnect 
         Alignment       =   1  'Right Justify
         Caption         =   "Connect Points (Yes/No): "
         Height          =   495
         Left            =   4320
         TabIndex        =   35
         Top             =   720
         Width           =   1935
      End
      Begin VB.Label lblDiameter 
         Alignment       =   1  'Right Justify
         Caption         =   "Diameter of Projection Circle (centimeter):  "
         Height          =   495
         Left            =   4200
         TabIndex        =   34
         Top             =   240
         Width           =   2055
      End
   End
   Begin VB.Frame fraZijderveld 
      Caption         =   "Zijderveld Projection (Use Declination, Inclination, Intensity Data)"
      Height          =   2175
      Left            =   120
      TabIndex        =   31
      Top             =   0
      Width           =   6975
      Begin MSComDlg.CommonDialog dlgPrinter 
         Left            =   4080
         Top             =   360
         _ExtentX        =   847
         _ExtentY        =   847
         _Version        =   393216
      End
      Begin VB.CommandButton cmdPrintMZPlot 
         Caption         =   "&2. Print M-Z-Plot"
         Height          =   375
         Left            =   2520
         TabIndex        =   5
         Top             =   720
         Width           =   1575
      End
      Begin VB.CommandButton cmdPrintZPlot 
         Caption         =   "&1. Print Z-Plot"
         Height          =   375
         Left            =   2520
         TabIndex        =   4
         Top             =   360
         Width           =   1575
      End
      Begin VB.Frame fraIncColor 
         Caption         =   "Inclination Color (Integer)"
         Height          =   855
         Left            =   4200
         TabIndex        =   51
         Top             =   1200
         Width           =   2655
         Begin VB.TextBox txtIncColorB 
            Height          =   375
            Left            =   2040
            TabIndex        =   14
            Text            =   "255"
            Top             =   360
            Width           =   495
         End
         Begin VB.TextBox txtIncColorG 
            Height          =   375
            Left            =   1200
            TabIndex        =   13
            Text            =   "0"
            Top             =   360
            Width           =   495
         End
         Begin VB.TextBox txtIncColorR 
            Height          =   375
            Left            =   360
            TabIndex        =   12
            Text            =   "0"
            Top             =   360
            Width           =   495
         End
         Begin VB.Label lblIncColorB 
            Caption         =   "B"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   1800
            TabIndex        =   54
            Top             =   360
            Width           =   255
         End
         Begin VB.Label lblIncColorG 
            Caption         =   "G"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   960
            TabIndex        =   53
            Top             =   360
            Width           =   255
         End
         Begin VB.Label lblIncColorR 
            Caption         =   "R"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   120
            TabIndex        =   52
            Top             =   360
            Width           =   255
         End
      End
      Begin VB.Frame fraDecColor 
         Caption         =   "Declination Color / Symbol Size (Integer)"
         Height          =   855
         Left            =   120
         TabIndex        =   46
         Top             =   1200
         Width           =   3975
         Begin VB.TextBox txtDecColorR 
            Height          =   375
            Left            =   360
            TabIndex        =   8
            Text            =   "255"
            Top             =   360
            Width           =   495
         End
         Begin VB.TextBox txtDecColorG 
            Height          =   375
            Left            =   1200
            TabIndex        =   9
            Text            =   "0"
            Top             =   360
            Width           =   495
         End
         Begin VB.TextBox txtDecColorB 
            Height          =   375
            Left            =   2040
            TabIndex        =   10
            Text            =   "0"
            Top             =   360
            Width           =   495
         End
         Begin VB.TextBox txtDecSize 
            Height          =   375
            Left            =   3120
            TabIndex        =   11
            Text            =   "4"
            Top             =   360
            Width           =   615
         End
         Begin VB.Label lblDecColorR 
            Caption         =   "R"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   120
            TabIndex        =   50
            Top             =   360
            Width           =   255
         End
         Begin VB.Label lblDecColorG 
            Caption         =   "G"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   960
            TabIndex        =   49
            Top             =   360
            Width           =   255
         End
         Begin VB.Label lblDecColorB 
            Caption         =   "B"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   1800
            TabIndex        =   48
            Top             =   360
            Width           =   255
         End
         Begin VB.Label lblDecSize 
            Caption         =   "Size"
            BeginProperty Font 
               Name            =   "MS Sans Serif"
               Size            =   12
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   375
            Left            =   2640
            TabIndex        =   47
            Top             =   360
            Width           =   495
         End
      End
      Begin VB.TextBox txtLength 
         Height          =   360
         Left            =   6120
         TabIndex        =   7
         Text            =   "15"
         Top             =   720
         Width           =   735
      End
      Begin VB.TextBox txtPlane 
         Height          =   375
         Left            =   6120
         TabIndex        =   6
         Text            =   "0"
         Top             =   300
         Width           =   735
      End
      Begin VB.CommandButton cmdMZPlot 
         Caption         =   "&Modified Z-Projection"
         Height          =   375
         Left            =   120
         TabIndex        =   3
         Top             =   720
         Width           =   2415
      End
      Begin VB.CommandButton cmdZPlot 
         Caption         =   "&Zijderveld Projection"
         Height          =   375
         Left            =   120
         TabIndex        =   2
         Top             =   360
         Width           =   2415
      End
      Begin VB.Label lblLength 
         Alignment       =   1  'Right Justify
         Caption         =   "Length of x and y axis (centimeter): "
         Height          =   495
         Left            =   4080
         TabIndex        =   36
         Top             =   720
         Width           =   2055
      End
      Begin VB.Label lblPlane 
         Alignment       =   1  'Right Justify
         Caption         =   "Projection Plane (degree): "
         Height          =   495
         Left            =   4560
         TabIndex        =   32
         Top             =   240
         Width           =   1575
      End
   End
   Begin VB.TextBox txtData 
      Height          =   3000
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      ToolTipText     =   "Type, or copy and paste data here. If no intensity data, default to one."
      Top             =   4710
      Width           =   3615
   End
   Begin VB.Label lblDown 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Down(x3)"
      Height          =   315
      Left            =   6600
      TabIndex        =   57
      Top             =   4380
      Width           =   1200
   End
   Begin VB.Label lblEast 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "East (x2)"
      Height          =   315
      Left            =   5400
      TabIndex        =   56
      Top             =   4380
      Width           =   1200
   End
   Begin VB.Label lblNorth 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "North (x1)"
      Height          =   315
      Left            =   4200
      TabIndex        =   55
      Top             =   4380
      Width           =   1200
   End
   Begin VB.Label lblIntensity 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Intensity"
      Height          =   315
      Left            =   2460
      TabIndex        =   30
      Top             =   4380
      Width           =   1170
   End
   Begin VB.Label lblInclination 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Inclination"
      Height          =   315
      Left            =   1290
      TabIndex        =   29
      Top             =   4380
      Width           =   1170
   End
   Begin VB.Label lblDeclination 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Declination"
      Height          =   315
      Left            =   120
      TabIndex        =   28
      Top             =   4380
      Width           =   1170
   End
End
Attribute VB_Name = "frmProjections"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type PointDataType
    Declination As Single
    Inclination As Single
    Intensity As Single
End Type

Private Type CartDataType
    North As Single
    East As Single
    Down As Single
End Type

Private Points() As PointDataType
Private PointIndex As Long

Private CPoints() As CartDataType
Private CPointIndex As Long

Private CenterX As Single, CenterY As Single
Private CurrX As Single, CurrY As Single, DX As Single, DY As Single
Private RSample As Single
Private Connect As Boolean, ModifyYN As Boolean, InputCorrect As Boolean
Private DecX() As Single, DecY() As Single, IncX() As Single, IncY() As Single 'For Zijderveld Projection
Private Plane As Single
Private DecColor As ColorConstants, IncColor As ColorConstants, ZPlotSymSize As Integer
Private SymbolColor As ColorConstants, LineColor As ColorConstants, SPlotSymSize As Integer

Private Sub GetData()
    Dim Data As String, Length As Long, I As Long
    Dim NextChar As String
    Dim Temp1 As String, Temp2 As String, Temp3 As String
    Dim Start As Long, NumChar As Integer
    ReDim Points(0 To 0) As PointDataType
    
    On Error GoTo ErrHandler
    
    Data = txtData.Text
    Length = Len(Data)
    
    Temp1 = ""
    Temp2 = ""
    Temp3 = ""
    PointIndex = 0
    
    For I = 1 To Length
        Start = I
        NumChar = 0
        NextChar = Mid(Data, Start, 1)
        While (NextChar = "" Or NextChar = Chr(10) Or NextChar = " " Or NextChar = Chr(13) Or NextChar = Chr(9)) And Start < Length
            Start = Start + 1
            NextChar = Mid(Data, Start, 1)
        Wend
        
        If Start >= Length Then Exit For
        
        Do
            NextChar = Mid(Data, Start + NumChar, 1)
            NumChar = NumChar + 1
        Loop Until NextChar = " " Or NextChar = "," Or NextChar = Chr(9)
        
        Temp1 = Mid(Data, Start, NumChar - 1)
        
        Start = Start + NumChar - 1
        NumChar = 0
        NextChar = Mid(Data, Start, 1)
        While NextChar = " " Or NextChar = "," Or NextChar = Chr(9)
            Start = Start + 1
            NextChar = Mid(Data, Start, 1)
        Wend

        Do
            NextChar = Mid(Data, Start + NumChar, 1)
            NumChar = NumChar + 1
        Loop Until NextChar = " " Or NextChar = "," Or NextChar = Chr(9) Or NextChar = "" Or NextChar = Chr(13)

        Temp2 = Mid(Data, Start, NumChar - 1)
        
        Start = Start + NumChar - 1
        NumChar = 0
        NextChar = Mid(Data, Start, 1)
        If NextChar = Chr(13) Or NextChar = "" Then 'No Intensity Data
            Temp3 = 1
        Else
            While NextChar = " " Or NextChar = "," Or NextChar = Chr(9)
                Start = Start + 1
                NextChar = Mid(Data, Start, 1)
            Wend
            
            Do
                NextChar = Mid(Data, Start + NumChar, 1)
                NumChar = NumChar + 1
            Loop Until NextChar = " " Or NextChar = "," Or NextChar = Chr(9) Or NextChar = "" Or NextChar = Chr(13)
            
            If NumChar = 1 And (NextChar = Chr(13) Or NextChar = "") Then
                Temp3 = 1
            Else
                Temp3 = Mid(Data, Start, NumChar - 1)
            End If
        End If

        PointIndex = UBound(Points()) + 1
        ReDim Preserve Points(0 To PointIndex) As PointDataType
        Points(PointIndex).Declination = CSng(Temp1)
        Points(PointIndex).Inclination = CSng(Temp2)
        Points(PointIndex).Intensity = CSng(Temp3)
        
        I = Start + NumChar - 1
    Next I
ErrHandler:
    Exit Sub
End Sub

Private Sub CGetData()
    Dim Data As String, Length As Long, I As Long
    Dim NextChar As String
    Dim Temp1 As String, Temp2 As String, Temp3 As String
    Dim Start As Long, NumChar As Integer
    ReDim CPoints(0 To 0) As CartDataType
    
    On Error GoTo ErrHandler
    
    Data = txtCartData.Text
    Length = Len(Data)
    
    Temp1 = ""
    Temp2 = ""
    Temp3 = ""
    CPointIndex = 0
    
    For I = 1 To Length
        Start = I
        NumChar = 0
        NextChar = Mid(Data, Start, 1)
        While (NextChar = "" Or NextChar = Chr(10) Or NextChar = " " Or NextChar = Chr(13) Or NextChar = Chr(9)) And Start < Length
            Start = Start + 1
            NextChar = Mid(Data, Start, 1)
        Wend
        
        If Start >= Length Then Exit For
        
        Do
            NextChar = Mid(Data, Start + NumChar, 1)
            NumChar = NumChar + 1
        Loop Until NextChar = " " Or NextChar = "," Or NextChar = Chr(9)
        
        Temp1 = Mid(Data, Start, NumChar - 1)
        
        Start = Start + NumChar - 1
        NumChar = 0
        NextChar = Mid(Data, Start, 1)
        While NextChar = " " Or NextChar = "," Or NextChar = Chr(9)
            Start = Start + 1
            NextChar = Mid(Data, Start, 1)
        Wend

        Do
            NextChar = Mid(Data, Start + NumChar, 1)
            NumChar = NumChar + 1
        Loop Until NextChar = " " Or NextChar = "," Or NextChar = Chr(9) Or NextChar = "" Or NextChar = Chr(13)

        Temp2 = Mid(Data, Start, NumChar - 1)
        
        Start = Start + NumChar - 1
        NumChar = 0
        NextChar = Mid(Data, Start, 1)
        If NextChar = Chr(13) Or NextChar = "" Then 'No Down Data
            Temp3 = 1
        Else
            While NextChar = " " Or NextChar = "," Or NextChar = Chr(9)
                Start = Start + 1
                NextChar = Mid(Data, Start, 1)
            Wend
            
            Do
                NextChar = Mid(Data, Start + NumChar, 1)
                NumChar = NumChar + 1
            Loop Until NextChar = " " Or NextChar = "," Or NextChar = Chr(9) Or NextChar = "" Or NextChar = Chr(13)
            
            If NumChar = 1 And (NextChar = Chr(13) Or NextChar = "") Then
                Temp3 = 1
            Else
                Temp3 = Mid(Data, Start, NumChar - 1)
            End If
        End If

        CPointIndex = UBound(CPoints()) + 1
        ReDim Preserve CPoints(0 To CPointIndex) As CartDataType
        CPoints(CPointIndex).North = CSng(Temp1)
        CPoints(CPointIndex).East = CSng(Temp2)
        CPoints(CPointIndex).Down = CSng(Temp3)
        
        I = Start + NumChar - 1
    Next I
    
ErrHandler:
    Exit Sub
End Sub
Private Sub cmdCartToSphe_Click()
    Dim I As Long
    
    If txtCartData.Text = "" Then
        Call MsgBox("No North(x1), East(x2), and Down(x3) data available!", vbOKOnly)
        Call txtCartData.SetFocus
        Exit Sub
    End If
    Call CGetData
    PointIndex = CPointIndex
    ReDim Points(1 To PointIndex)
    
    txtData.Text = ""
    
    For I = 1 To CPointIndex
        Points(I).Intensity = Sqr(CPoints(I).North ^ 2 + CPoints(I).East ^ 2 + CPoints(I).Down ^ 2)
        Points(I).Declination = RadToDeg(ArcTan(CPoints(I).North, CPoints(I).East))
        If Sqr(CPoints(I).North ^ 2 + CPoints(I).East ^ 2) < 0.000001 Then
            If CPoints(I).Down >= 0 Then
                Points(I).Inclination = RadToDeg(PI / 2)
            Else
                Points(I).Inclination = RadToDeg(-PI / 2)
            End If
        Else
            Points(I).Inclination = RadToDeg(Atn(CPoints(I).Down / Sqr(CPoints(I).North ^ 2 + CPoints(I).East ^ 2)))
        End If
        txtData.Text = txtData.Text & RightAlign(Format(Points(I).Declination, "0.00"), 16) _
            & RightAlign(Format(Points(I).Inclination, "0.00"), 14) _
            & RightAlign(Format(Points(I).Intensity, "0.000000"), 16) & vbCrLf
    Next I
End Sub

Private Sub cmdClearPlotArea_Click()
    Call frmPointsPlot.picPointsPlot.Cls
End Sub

Private Sub cmdEllipseEQPlot_Click()
    Dim Diameter As Single, AxisLength As Single
    Dim Latitude As Single, Longitude As Single 'Sample site
    Dim Declination As Single, Inclination As Single, Alpha95 As Single
    Dim NumPoints As Long   'Number of points to draw
    Dim LineThickness As Single
    Dim PlotSampleCIrcleYN As Boolean
    
    InputCorrect = True
    Call GetEllipseInput(Diameter, SymbolColor, LineColor, SPlotSymSize, Latitude, Longitude, NumPoints, _
        LineThickness, Declination, Inclination, Alpha95)
    If InputCorrect = False Then Exit Sub
        
    Call ResizePlotArea(Diameter, AxisLength, 2)
    
    If MsgBox("Plot 95% Confidence Circle around mean declination and inclination of sample?", vbYesNo) = vbYes Then
        PlotSampleCIrcleYN = True
    Else
        PlotSampleCIrcleYN = False
    End If
       
    Call frmPointsPlot.Show
    Call EQPlotBackground(AxisLength / 2)
    Call EllipsePlotSub(NumPoints, Latitude, Longitude, Declination, Inclination, Alpha95, AxisLength, _
        SPlotSymSize, SymbolColor, LineThickness, LineColor, PlotSampleCIrcleYN, 2)
End Sub

Private Sub cmdEllipseSPlot_Click()
    Dim Diameter As Single, AxisLength As Single
    Dim Latitude As Single, Longitude As Single 'Sample site
    Dim Declination As Single, Inclination As Single, Alpha95 As Single
    Dim NumPoints As Long   'Number of points to draw
    Dim LineThickness As Single
    Dim PlotSampleCIrcleYN As Boolean
    
    InputCorrect = True
    Call GetEllipseInput(Diameter, SymbolColor, LineColor, SPlotSymSize, Latitude, Longitude, NumPoints, _
        LineThickness, Declination, Inclination, Alpha95)
    If InputCorrect = False Then Exit Sub
    
    Call ResizePlotArea(Diameter, AxisLength, 1)
    
    If MsgBox("Plot 95% Confidence Circle around mean declination and inclination of sample?", vbYesNo) = vbYes Then
        PlotSampleCIrcleYN = True
    Else
        PlotSampleCIrcleYN = False
    End If
       
    Call frmPointsPlot.Show
    Call SPlotBackground(AxisLength / 2)
    Call EllipsePlotSub(NumPoints, Latitude, Longitude, Declination, Inclination, Alpha95, AxisLength, _
        SPlotSymSize, SymbolColor, LineThickness, LineColor, PlotSampleCIrcleYN, 1)
End Sub

Private Sub cmdEQPlot_Click()
    Dim Diameter As Single, AxisLength As Single
    
    Call GetPlotInfo(Diameter)
    Call ResizePlotArea(Diameter, AxisLength, 2)
    Call frmPointsPlot.Show
    Call GetData
    If PointIndex = 0 Then
        Call MsgBox("No data available. Check your input.", vbOKOnly)
        Exit Sub
    End If
    Call frmPointsPlot.picPointsPlot.Cls
    Call EQPlotBackground(AxisLength / 2)
    Call EQPlotDisplay(AxisLength / 2)
End Sub

Private Sub cmdFisher_Click()
    Dim I As Long, N As Long 'I: Counter; N: numbers of samples/points
    Dim NTotal As Single, ETotal As Single, DownTotal As Single
    Dim R As Single 'Length of the sum vector
    Dim N_Minus_R As Single, k As Single 'k: estimation of the precision
    Dim P As Single 'P: Error percentage. 1-P = Confidence Level, i.e., if Confidence Level = 0.95, P = 0.05
    Dim Dispersion_Angle As Single
    Dim FisherDec As Single, FisherInc As Single 'Declination and Inclination calculated by Fisher
    
    If txtCartData.Text = "" Then
        Call MsgBox("No North(x1), East(x2), and Down(x3) data available!", vbOKOnly)
        Call txtCartData.SetFocus
        Exit Sub
    End If
    Call CGetData
    
    NTotal = 0
    ETotal = 0
    DownTotal = 0
    For I = 1 To CPointIndex
        NTotal = NTotal + CPoints(I).North
        ETotal = ETotal + CPoints(I).East
        DownTotal = DownTotal + CPoints(I).Down
    Next I
    
    Call XYZToDecInc(ETotal, NTotal, DownTotal, FisherDec, FisherInc)
    If IsNumeric(txtSignificanceLevel.Text) = False Then
        Call MsgBox("Significance level must be a number between 0 and 1. Default to 0.05.", vbOKOnly)
        P = 0.05
    Else
        P = CSng(txtSignificanceLevel.Text)
    End If
        
    R = Sqr(NTotal ^ 2 + ETotal ^ 2 + DownTotal ^ 2)
    N = CPointIndex
    N_Minus_R = N - R
    k = (N - 1) / (N - R)
    Dispersion_Angle = RadToDeg(ArcCos(1 - (N_Minus_R * ((1 / P) ^ (1 / (N - 1)) - 1) / R)))
    txtFisherDec.Text = Format(FisherDec, "0.00")
    txtFisherInc.Text = Format(FisherInc, "0.00")
    txtAlpha95.Text = Format(Dispersion_Angle, "0.00")
    txtK.Text = Format(k, "0.00")
End Sub

Private Sub cmdMZPlot_Click()
    Dim Length As Single, AxisLength As Single
    
    ModifyYN = True
    
    Call GetZPlotInfo(Length)
    Call ResizeZPlotArea(Length, AxisLength, 2)
    Call frmPointsPlot.Show
    Call GetData
    If PointIndex = 0 Then
        Call MsgBox("No data available. Check your input.", vbOKOnly)
        Exit Sub
    End If
    Call frmPointsPlot.picPointsPlot.Cls
    Call PointsZPlot(AxisLength)
End Sub

Private Sub cmdPrintEllipseEQPlot_Click()
    Dim Diameter As Single, AxisLength As Single
    Dim Latitude As Single, Longitude As Single 'Sample site
    Dim Declination As Single, Inclination As Single, Alpha95 As Single
    Dim NumPoints As Long   'Number of points to draw
    Dim LineThickness As Single
    Dim PlotSampleCIrcleYN As Boolean
    
    Dim BeginPage, EndPage, NumCopies, Orientation, J As Long 'J: Copies
        
    InputCorrect = True
    Call GetEllipseInput(Diameter, SymbolColor, LineColor, SPlotSymSize, Latitude, Longitude, NumPoints, _
        LineThickness, Declination, Inclination, Alpha95)
    If InputCorrect = False Then Exit Sub
    
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
        
    AxisLength = 1440 * Diameter / 2.54
    
    If MsgBox("Plot 95% Confidence Circle around mean declination and inclination of sample?", vbYesNo) = vbYes Then
        PlotSampleCIrcleYN = True
    Else
        PlotSampleCIrcleYN = False
    End If
       
    For J = 1 To NumCopies
        Call PrintEQPlotBackground(AxisLength / 2)
        Call EllipsePrintSub(NumPoints, Latitude, Longitude, Declination, Inclination, Alpha95, AxisLength, _
            SPlotSymSize, SymbolColor, LineThickness, LineColor, PlotSampleCIrcleYN, 2)
    Next J
    
    If MsgBox("Print Now? If so, click Yes. If you want to print other " _
        & " ellipses on the same diagram, click No.", vbYesNo, "Confirmation of printing") = vbYes Then
        Printer.EndDoc
    End If
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

Private Sub cmdPrintEllipseSPlot_Click()
    Dim Diameter As Single, AxisLength As Single
    Dim Latitude As Single, Longitude As Single 'Sample site
    Dim Declination As Single, Inclination As Single, Alpha95 As Single
    Dim NumPoints As Long   'Number of points to draw
    Dim LineThickness As Single
    Dim PlotSampleCIrcleYN As Boolean
    
    Dim BeginPage, EndPage, NumCopies, Orientation, J As Long 'J: Copies
        
    InputCorrect = True
    Call GetEllipseInput(Diameter, SymbolColor, LineColor, SPlotSymSize, Latitude, Longitude, NumPoints, _
        LineThickness, Declination, Inclination, Alpha95)
    If InputCorrect = False Then Exit Sub
    
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
        
    AxisLength = 1440 * Diameter / 2.54
    
    If MsgBox("Plot 95% Confidence Circle around mean declination and inclination of sample?", vbYesNo) = vbYes Then
        PlotSampleCIrcleYN = True
    Else
        PlotSampleCIrcleYN = False
    End If
       
    For J = 1 To NumCopies
        Call PrintSPlotBackground(AxisLength / 2)
        Call EllipsePrintSub(NumPoints, Latitude, Longitude, Declination, Inclination, Alpha95, AxisLength, _
            SPlotSymSize, SymbolColor, LineThickness, LineColor, PlotSampleCIrcleYN, 1)
    Next J
    
    If MsgBox("Print Now? If so, click Yes. If you want to print other " _
        & " ellipses on the same diagram, click No.", vbYesNo, "Confirmation of printing") = vbYes Then
        Printer.EndDoc
    End If
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

Private Sub cmdPrintEqAPlot_Click()
    Dim Diameter As Single, AxisLength As Single
    Dim BeginPage, EndPage, NumCopies, Orientation, I
    
    Call GetPlotInfo(Diameter)
    AxisLength = 1440 * Diameter / 2.54
    
    Call GetData
    If PointIndex = 0 Then
        Call MsgBox("No data available. Check your input.", vbOKOnly)
        Exit Sub
    End If
        
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
    For I = 1 To NumCopies
        Call PrintEQPlotBackground(AxisLength / 2)
        Call PrintEQPlotDisplay(AxisLength / 2)
    Next I
    
    If MsgBox("Print Now? If so, click Yes. If you want to print other " _
        & " ellipses on the same diagram, click No.", vbYesNo, "Confirmation of printing") = vbYes Then
        Printer.EndDoc
    End If
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

Private Sub cmdPrintMZPlot_Click()
    Dim Length As Single, AxisLength As Single
    Dim BeginPage, EndPage, NumCopies, Orientation, I

    ModifyYN = True
    Call GetZPlotInfo(Length)
    
    AxisLength = 1440 * Length / 2.54
        
    Call GetData
    If PointIndex = 0 Then
        Call MsgBox("No data available. Check your input.", vbOKOnly)
        Exit Sub
    End If
    
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
    For I = 1 To NumCopies
        Call PrintPointsZPlot(AxisLength)
    Next I
    Printer.EndDoc
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

Private Sub cmdPrintSPlot_Click()
    Dim Diameter As Single, AxisLength As Single
    Dim BeginPage, EndPage, NumCopies, Orientation, I
    
    Call GetPlotInfo(Diameter)
    AxisLength = 1440 * Diameter / 2.54
    
    Call GetData
    If PointIndex = 0 Then
        Call MsgBox("No data available. Check your input.", vbOKOnly)
        Exit Sub
    End If
    
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
    For I = 1 To NumCopies
        Call PrintSPlotBackground(AxisLength / 2)
        Call PrintSPlotDisplay(AxisLength / 2)
    Next I
    
    If MsgBox("Print Now? If so, click Yes. If you want to print other " _
        & " ellipses on the same diagram, click No.", vbYesNo, "Confirmation of printing") = vbYes Then
        Printer.EndDoc
    End If
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

Private Sub cmdPrintZPlot_Click()
    Dim Length As Single, AxisLength As Single
    Dim BeginPage, EndPage, NumCopies, Orientation, I
    
    ModifyYN = False
    
    Call GetZPlotInfo(Length)
    AxisLength = 1440 * Length / 2.54
    
    Call GetData
    If PointIndex = 0 Then
        Call MsgBox("No data available. Check your input.", vbOKOnly)
        Exit Sub
    End If
    
    ' Set Cancel to True.
    dlgPrinter.CancelError = True
    On Error GoTo ErrHandler
    ' Display the Print dialog box.
    dlgPrinter.ShowPrinter
    ' Get user-selected values from the dialog box.
    BeginPage = dlgPrinter.FromPage
    EndPage = dlgPrinter.ToPage
    NumCopies = dlgPrinter.Copies
    Orientation = dlgPrinter.Orientation
    For I = 1 To NumCopies
        Call PrintPointsZPlot(AxisLength)
    Next I
    Printer.EndDoc
    Exit Sub
ErrHandler:
    ' User pressed Cancel button.
    Exit Sub
End Sub

Private Sub cmdSpheToCart_Click()
    Dim I As Long
    
    If txtData.Text = "" Then
        Call MsgBox("No Declination, Inclination, and Intensity data available!", vbOKOnly)
        Call txtData.SetFocus
        Exit Sub
    End If
    
    Call GetData
    CPointIndex = PointIndex
    ReDim CPoints(1 To CPointIndex)
    
    txtCartData.Text = ""
    
    For I = 1 To PointIndex
        CPoints(I).North = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination)) * Cos(DegToRad(Points(I).Declination))
        CPoints(I).East = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination)) * Sin(DegToRad(Points(I).Declination))
        CPoints(I).Down = Points(I).Intensity * Sin(DegToRad(Points(I).Inclination))
        txtCartData.Text = txtCartData.Text & RightAlign(Format(CPoints(I).North, "0.000000"), 16) _
            & RightAlign(Format(CPoints(I).East, "0.000000"), 16) _
            & RightAlign(Format(CPoints(I).Down, "0.000000"), 16) & vbCrLf
    Next I
End Sub

Private Sub cmdStereoPlot_Click()
    Dim Diameter As Single, AxisLength As Single
    
    Call GetPlotInfo(Diameter)
    Call ResizePlotArea(Diameter, AxisLength, 2)
    Call frmPointsPlot.Show
    Call GetData
    If PointIndex = 0 Then
        Call MsgBox("No data available. Check your input.", vbOKOnly)
        Exit Sub
    End If
    Call frmPointsPlot.picPointsPlot.Cls
    Call SPlotBackground(AxisLength / 2)
    Call SPlotDisplay(AxisLength / 2)
End Sub

'Tauxe (1998): "Paleomagnetic Principles and Practice", page 19 to 20
Private Sub cmdVGPCalculate_Click()
    Dim SampleDec As Single, SampleInc As Single, SampleLat As Single, SampleLong As Single
    Dim SampleCo_Lat As Single
    Dim Alpha95 As Single, CoLat As Single, DP As Single, DM As Single
    Dim Magnetic_Co_Lat As Single 'Magnetic Co_latitude
    Dim VGPLat As Single, VGPLong As Single, VGPCo_Lat As Single
    Dim DeltaVGPLong As Single
    
    If txtFisherDec.Text = "" Or txtFisherInc.Text = "" Or txtLat.Text = "" Or txtLong.Text = "" Then
        Call MsgBox("Insufficient Data. Check you input!", vbOKOnly, "VGP Data Input")
        Call txtLat.SetFocus
        Exit Sub
    ElseIf IsNumeric(txtFisherDec.Text) = False Or IsNumeric(txtFisherInc.Text) = False _
        Or IsNumeric(txtLat.Text) = False Or IsNumeric(txtLong.Text) = False Then
        Call MsgBox("One or more input is/are not a number(s). Check you input!", vbOKOnly, "VGP Data Input")
        Call txtLat.SetFocus
        Exit Sub
    End If
    
    'Get data, and transform to radian
    SampleDec = DegToRad(CSng(txtFisherDec.Text))
    SampleInc = DegToRad(CSng(txtFisherInc.Text))
    SampleLat = DegToRad(CSng(txtLat.Text))
    SampleLong = DegToRad(CSng(txtLong.Text))
    
    Call VGPFromSite(SampleDec, SampleInc, SampleLat, SampleLong, VGPLat, VGPLong)
    txtVGPPoleLat.Text = Format(VGPLat, "0.00")
    txtVGPPoleLong.Text = Format(VGPLong, "0.00")
        
    If txtAlpha95.Text <> "" Then
        If IsNumeric(txtAlpha95.Text) = True Then
            Alpha95 = DegToRad(CSng(txtAlpha95.Text))
            CoLat = Atn(2 / Tan(SampleInc))
            If CoLat < 0 Then CoLat = CoLat + PI
            DP = RadToDeg(Alpha95 * (1 + 3 * Cos(CoLat) * Cos(CoLat)) / 2)
            DM = RadToDeg(Alpha95 * Sin(CoLat) / Cos(SampleInc))
            txtDP.Text = Format(DP, "0.00")
            txtDM.Text = Format(DM, "0.00")
        End If
    End If
End Sub

Private Sub cmdVGPToSampleDecInc_Click()
    Dim SampleDec As Single, SampleInc As Single, SampleLat As Single, SampleLong As Single
    Dim SampleCo_Lat As Single
    Dim Magnetic_Co_Lat As Single 'Magnetic Co_latitude
    Dim VGPLat As Single, VGPLong As Single, VGPCo_Lat As Single
    Dim DeltaVGPLong As Single
    
    If txtVGPPoleLat.Text = "" Or txtVGPPoleLong.Text = "" Or txtLat.Text = "" Or txtLong.Text = "" Then
        Call MsgBox("Insufficient Data. Check you input!", vbOKOnly, "VGP Data Input")
        Call txtLat.SetFocus
        Exit Sub
    ElseIf IsNumeric(txtVGPPoleLat.Text) = False Or IsNumeric(txtVGPPoleLong.Text) = False _
        Or IsNumeric(txtLat.Text) = False Or IsNumeric(txtLong.Text) = False Then
        Call MsgBox("One or more input is/are not a number(s). Check you input!", vbOKOnly, "VGP Data Input")
        Call txtLat.SetFocus
        Exit Sub
    End If
    
    'Get data, and transform to radian
    SampleLat = DegToRad(CSng(txtLat.Text))
    SampleLong = DegToRad(CSng(txtLong.Text))
    SampleCo_Lat = PI / 2 - SampleLat
    
    VGPLat = DegToRad(txtVGPPoleLat.Text)
    VGPLong = DegToRad(txtVGPPoleLong.Text)
    VGPCo_Lat = PI / 2 - VGPLat

    DeltaVGPLong = VGPLong - SampleLong
    
    Magnetic_Co_Lat = ArcCos(Cos(SampleCo_Lat) * Cos(VGPCo_Lat) + Sin(SampleCo_Lat) * Sin(VGPCo_Lat) * Cos(DeltaVGPLong))
    
    If Magnetic_Co_Lat = 0 Then
        SampleInc = PI / 2  'How about -PI/2??
    Else
        SampleInc = Atn(2 * Tan(PI / 2 - Magnetic_Co_Lat))
    End If
    
    SampleDec = ArcSin(Sin(VGPCo_Lat) * Sin(DeltaVGPLong) / Sin(Magnetic_Co_Lat))
    
    If Cos(VGPCo_Lat) < Cos(SampleCo_Lat) * Cos(Magnetic_Co_Lat) Then
        SampleDec = PI - SampleDec
    End If
    
    If SampleDec < 0 Then
        SampleDec = SampleDec + 2 * PI
    ElseIf SampleDec > 2 * PI Then
        SampleDec = SampleDec - 2 * PI
    End If
       
    txtFisherDec.Text = Format(RadToDeg(SampleDec), "0.00")
    txtFisherInc.Text = Format(RadToDeg(SampleInc), "0.00")
End Sub

Private Sub cmdZPlot_Click()
    Dim Length As Single, AxisLength As Single
    
    ModifyYN = False
    
    Call GetZPlotInfo(Length)
    Call ResizeZPlotArea(Length, AxisLength, 1)
    Call frmPointsPlot.Show
    Call GetData
    If PointIndex = 0 Then
        Call MsgBox("No data available. Check your input.", vbOKOnly)
        Exit Sub
    End If
    Call frmPointsPlot.picPointsPlot.Cls
    Call PointsZPlot(AxisLength)
End Sub


'Purpose:   To display the background of Stereographic projection.
Private Sub SPlotBackground(ByVal Radius As Single)
    Dim Inclination As Single
    Dim Theta As Single
     
    CenterX = frmPointsPlot.picPointsPlot.ScaleWidth / 2
    CenterY = frmPointsPlot.picPointsPlot.ScaleHeight / 2
    
    frmPointsPlot.picPointsPlot.FillStyle = 1
    frmPointsPlot.picPointsPlot.Circle (CenterX, CenterY), Radius
    For Inclination = 10 To 80 Step 10
        frmPointsPlot.picPointsPlot.Circle (CenterX, CenterY), SPlotRadius(Radius, Inclination)
    Next Inclination
    For Theta = 0 To 170 Step 10
        frmPointsPlot.picPointsPlot.Line (CenterX + Radius * Cos(DegToRad(Theta)), _
            CenterY + Radius * Sin(DegToRad(Theta)))- _
            (CenterX - Radius * Cos(DegToRad(Theta)), _
            CenterY - Radius * Sin(DegToRad(Theta)))
    Next Theta
    frmPointsPlot.picPointsPlot.CurrentX = CenterX - 100
    frmPointsPlot.picPointsPlot.CurrentY = CenterY - Radius - 240
    frmPointsPlot.picPointsPlot.Print "N"
    frmPointsPlot.picPointsPlot.CurrentX = CenterX + Radius + 40
    frmPointsPlot.picPointsPlot.CurrentY = CenterY - 120
    frmPointsPlot.picPointsPlot.Print "E"
    frmPointsPlot.picPointsPlot.CurrentX = CenterX - 100
    frmPointsPlot.picPointsPlot.CurrentY = CenterY + Radius + 30
    frmPointsPlot.picPointsPlot.Print "S"
    frmPointsPlot.picPointsPlot.CurrentX = CenterX - Radius - 220
    frmPointsPlot.picPointsPlot.CurrentY = CenterY - 120
    frmPointsPlot.picPointsPlot.Print "W"
End Sub

'Purpose:   To display the background of Lambert Equal-area projection.
Private Sub EQPlotBackground(ByVal Radius As Single)
    Dim Inclination As Single
    Dim Theta As Single
     
    CenterX = frmPointsPlot.picPointsPlot.ScaleWidth / 2
    CenterY = frmPointsPlot.picPointsPlot.ScaleHeight / 2
    
    frmPointsPlot.picPointsPlot.FillStyle = 1
    frmPointsPlot.picPointsPlot.Circle (CenterX, CenterY), Radius
    For Inclination = 10 To 80 Step 10
        frmPointsPlot.picPointsPlot.Circle (CenterX, CenterY), EQPlotRadius(Radius, Inclination)
    Next Inclination
    For Theta = 0 To 170 Step 10
        frmPointsPlot.picPointsPlot.Line (CenterX + Radius * Cos(DegToRad(Theta)), _
            CenterY + Radius * Sin(DegToRad(Theta)))- _
            (CenterX - Radius * Cos(DegToRad(Theta)), _
            CenterY - Radius * Sin(DegToRad(Theta)))
    Next Theta
    frmPointsPlot.picPointsPlot.CurrentX = CenterX - 100
    frmPointsPlot.picPointsPlot.CurrentY = CenterY - Radius - 240
    frmPointsPlot.picPointsPlot.Print "N"
    frmPointsPlot.picPointsPlot.CurrentX = CenterX + Radius + 40
    frmPointsPlot.picPointsPlot.CurrentY = CenterY - 120
    frmPointsPlot.picPointsPlot.Print "E"
    frmPointsPlot.picPointsPlot.CurrentX = CenterX - 100
    frmPointsPlot.picPointsPlot.CurrentY = CenterY + Radius + 30
    frmPointsPlot.picPointsPlot.Print "S"
    frmPointsPlot.picPointsPlot.CurrentX = CenterX - Radius - 220
    frmPointsPlot.picPointsPlot.CurrentY = CenterY - 120
    frmPointsPlot.picPointsPlot.Print "W"
End Sub


'Purpose:   To display data using Lambert Equal-area projection.
Private Sub EQPlotDisplay(ByVal Radius As Single)
    Dim Counter As Long, PrevCounter As Long
    
    PrevCounter = 0
    
    If IsNumeric(txtSymColorR.Text) = False Or IsNumeric(txtSymColorG.Text) = False Or _
        IsNumeric(txtSymColorB.Text) = False Or IsNumeric(txtLineColorR.Text) = False Or _
        IsNumeric(txtLineColorG.Text) = False Or IsNumeric(txtLineColorB.Text) = False Then
            Call MsgBox("Color values must be Integers!", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    ElseIf (CInt(txtSymColorR.Text) < 0 Or CInt(txtSymColorR.Text) > 255) Or _
        (CInt(txtSymColorG.Text) < 0 Or CInt(txtSymColorG.Text) > 255) Or _
        (CInt(txtSymColorB.Text) < 0 Or CInt(txtSymColorB.Text) > 255) Or _
        (CInt(txtLineColorR.Text) < 0 Or CInt(txtLineColorR.Text) > 255) Or _
        (CInt(txtLineColorG.Text) < 0 Or CInt(txtLineColorG.Text) > 255) Or _
        (CInt(txtLineColorB.Text) < 0 Or CInt(txtLineColorB.Text) > 255) Then
            Call MsgBox("Color values must be in the range 0 to 255", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    End If
    
    If IsNumeric(txtSymSize.Text) = False Then
        Call MsgBox("Symbol size is not a number!", vbOKOnly, "Equal Area Plot Symbol Size")
        Call txtSymSize.SetFocus
        Exit Sub
    ElseIf CInt(txtSymSize.Text) < 1 Or CInt(txtSymSize.Text) > 100 Then
        Call MsgBox("Symbol size must be an integer (1 to 100)", vbOKOnly, "Equal Area Plot Symbol Size")
        Call txtSymSize.SetFocus
        Exit Sub
    End If
    
    SymbolColor = RGB(CInt(txtSymColorR.Text), CInt(txtSymColorG.Text), CInt(txtSymColorB.Text))
    LineColor = RGB(CInt(txtLineColorR.Text), CInt(txtLineColorG.Text), CInt(txtLineColorB.Text))
    SPlotSymSize = CInt(txtSymSize.Text)

    If Connect = True Then
        For Counter = 1 To PointIndex
            RSample = EQPlotRadius(Radius, Abs(Points(Counter).Inclination))
            Call DXDYCalc(DX, DY, RSample, Points(Counter).Declination)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Points(1).Inclination < 0 Then
                    frmPointsPlot.picPointsPlot.Line (CurrX - SPlotSymSize * 10, CurrY - SPlotSymSize * 10)-Step(SPlotSymSize * 20, SPlotSymSize * 20), SymbolColor, B
                Else
                    frmPointsPlot.picPointsPlot.Line (CurrX - SPlotSymSize * 10, CurrY - SPlotSymSize * 10)-Step(SPlotSymSize * 20, SPlotSymSize * 20), SymbolColor, BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call ConnectPoints(Radius, Points(PrevCounter).Declination, _
                        Points(PrevCounter).Inclination, Points(Counter).Declination, Points(Counter).Inclination, 2)
                    frmPointsPlot.picPointsPlot.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), _
                        LineColor
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Points(Counter).Inclination < 0 Then
                    frmPointsPlot.picPointsPlot.Circle (CurrX, CurrY), SPlotSymSize * 10, SymbolColor
                Else
                    frmPointsPlot.picPointsPlot.FillStyle = 0
                    frmPointsPlot.picPointsPlot.FillColor = SymbolColor
                    frmPointsPlot.picPointsPlot.Circle (CurrX, CurrY), SPlotSymSize * 10, SymbolColor
                    frmPointsPlot.picPointsPlot.FillStyle = 1
                    frmPointsPlot.picPointsPlot.FillColor = frmPointsPlot.picPointsPlot.ForeColor
                End If
            End If
        Next Counter
    Else
        For Counter = 1 To PointIndex
            RSample = EQPlotRadius(Radius, Abs(Points(Counter).Inclination))
            Call DXDYCalc(DX, DY, RSample, Points(Counter).Declination)
            Call CurrXY(CurrX, CurrY)
            If Points(Counter).Inclination < 0 Then
                frmPointsPlot.picPointsPlot.Circle (CurrX, CurrY), SPlotSymSize * 10, SymbolColor
            Else
                frmPointsPlot.picPointsPlot.FillStyle = 0
                frmPointsPlot.picPointsPlot.FillColor = SymbolColor
                frmPointsPlot.picPointsPlot.Circle (CurrX, CurrY), SPlotSymSize * 10, SymbolColor
                frmPointsPlot.picPointsPlot.FillStyle = 1
                frmPointsPlot.picPointsPlot.FillColor = frmPointsPlot.picPointsPlot.ForeColor
            End If
        Next Counter
    End If
End Sub


'Purpose:   To display data using Stereographic projection.
Private Sub SPlotDisplay(ByVal Radius As Single)
    Dim Counter As Long, PrevCounter As Long
    
    PrevCounter = 0
    
    If IsNumeric(txtSymColorR.Text) = False Or IsNumeric(txtSymColorG.Text) = False Or _
        IsNumeric(txtSymColorB.Text) = False Or IsNumeric(txtLineColorR.Text) = False Or _
        IsNumeric(txtLineColorG.Text) = False Or IsNumeric(txtLineColorB.Text) = False Then
            Call MsgBox("Color values must be Integers!", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    ElseIf (CInt(txtSymColorR.Text) < 0 Or CInt(txtSymColorR.Text) > 255) Or _
        (CInt(txtSymColorG.Text) < 0 Or CInt(txtSymColorG.Text) > 255) Or _
        (CInt(txtSymColorB.Text) < 0 Or CInt(txtSymColorB.Text) > 255) Or _
        (CInt(txtLineColorR.Text) < 0 Or CInt(txtLineColorR.Text) > 255) Or _
        (CInt(txtLineColorG.Text) < 0 Or CInt(txtLineColorG.Text) > 255) Or _
        (CInt(txtLineColorB.Text) < 0 Or CInt(txtLineColorB.Text) > 255) Then
            Call MsgBox("Color values must be in the range 0 to 255", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    End If
    
    If IsNumeric(txtSymSize.Text) = False Then
        Call MsgBox("Symbol size is not a number!", vbOKOnly, "Stereographic Plot Symbol Size")
        Call txtSymSize.SetFocus
        Exit Sub
    ElseIf CInt(txtSymSize.Text) < 1 Or CInt(txtSymSize.Text) > 100 Then
        Call MsgBox("Symbol size must be an integer (1 to 100)", vbOKOnly, "Stereographic Plot Symbol Size")
        Call txtSymSize.SetFocus
        Exit Sub
    End If
    
    SymbolColor = RGB(CInt(txtSymColorR.Text), CInt(txtSymColorG.Text), CInt(txtSymColorB.Text))
    LineColor = RGB(CInt(txtLineColorR.Text), CInt(txtLineColorG.Text), CInt(txtLineColorB.Text))
    SPlotSymSize = CInt(txtSymSize.Text)
    
    If Connect = True Then
        For Counter = 1 To PointIndex
            RSample = SPlotRadius(Radius, Abs(Points(Counter).Inclination))
            Call DXDYCalc(DX, DY, RSample, Points(Counter).Declination)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Points(1).Inclination < 0 Then
                    frmPointsPlot.picPointsPlot.Line (CurrX - 10 * SPlotSymSize, CurrY - 10 * SPlotSymSize)-Step(20 * SPlotSymSize, 20 * SPlotSymSize), SymbolColor, B
                Else
                    frmPointsPlot.picPointsPlot.Line (CurrX - 10 * SPlotSymSize, CurrY - 10 * SPlotSymSize)-Step(20 * SPlotSymSize, 20 * SPlotSymSize), SymbolColor, BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call ConnectPoints(Radius, Points(PrevCounter).Declination, _
                        Points(PrevCounter).Inclination, Points(Counter).Declination, Points(Counter).Inclination, 1)
                    frmPointsPlot.picPointsPlot.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), _
                        LineColor
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Points(Counter).Inclination < 0 Then
                    frmPointsPlot.picPointsPlot.Circle (CurrX, CurrY), 10 * SPlotSymSize, SymbolColor
                Else
                    frmPointsPlot.picPointsPlot.FillStyle = 0
                    frmPointsPlot.picPointsPlot.FillColor = SymbolColor
                    frmPointsPlot.picPointsPlot.Circle (CurrX, CurrY), 10 * SPlotSymSize, SymbolColor
                    frmPointsPlot.picPointsPlot.FillStyle = 1
                    frmPointsPlot.picPointsPlot.FillColor = frmPointsPlot.picPointsPlot.ForeColor
                End If
            End If
        Next Counter
    Else
        For Counter = 1 To PointIndex
            RSample = SPlotRadius(Radius, Abs(Points(Counter).Inclination))
            Call DXDYCalc(DX, DY, RSample, Points(Counter).Declination)
            Call CurrXY(CurrX, CurrY)
            If Points(Counter).Inclination < 0 Then
                frmPointsPlot.picPointsPlot.Circle (CurrX, CurrY), 10 * SPlotSymSize, SymbolColor
            Else
                frmPointsPlot.picPointsPlot.FillStyle = 0
                frmPointsPlot.picPointsPlot.FillColor = SymbolColor
                frmPointsPlot.picPointsPlot.Circle (CurrX, CurrY), 10 * SPlotSymSize, SymbolColor
                frmPointsPlot.picPointsPlot.FillStyle = 1
                frmPointsPlot.picPointsPlot.FillColor = frmPointsPlot.picPointsPlot.ForeColor
            End If
        Next Counter
    End If
End Sub


'Purpose:   To calculate DX and DY for stereographic projection.
'Theta:     Declination of Sample, i.e., from North to sample clockwise.
Private Sub DXDYCalc(ByRef DX As Single, ByRef DY As Single, _
    ByVal RSample As Single, ByVal Theta As Single)
            DX = RSample * Sin(DegToRad(Theta))
            DY = RSample * Cos(DegToRad(Theta))
End Sub

'Purpose:   To calculate the coordinates of the Current point to be plotted
Private Sub CurrXY(ByRef CurrX As Single, ByRef CurrY As Single)
    CurrX = CenterX + DX
    CurrY = CenterY - DY
End Sub

'Purpose:   To connect two points in Stereographic Projection or
'           Lambert Equal-area Projection
'Radius:    Radius of the projection circle.
'AngleDec1 & AngleDec2: Declination of the first and second points.
'AngleInc1 & AngleInc2: Inclination of the first and second points.
Private Sub ConnectPoints(ByVal Radius As Single, _
    ByVal AngleDec1 As Single, ByVal AngleInc1 As Single, _
    ByVal AngleDec2 As Single, ByVal AngleInc2 As Single, ByVal PlotType As Integer)
       
    Dim I As Integer, StepNumber As Integer
    Dim X1 As Single, Y1 As Single, Z1 As Single
    Dim X2 As Single, Y2 As Single, Z2 As Single
    Dim StepX As Single, StepY As Single, StepZ As Single
    Dim DecPoint As Single, IncPoint As Single
    
    
    Call XYZFromDecInc(X1, Y1, Z1, Radius, AngleDec1, AngleInc1)
    Call XYZFromDecInc(X2, Y2, Z2, Radius, AngleDec2, AngleInc2)
    StepNumber = 100         'Number of Steps from (X1, Y1, Z1) to (X2, Y2, Z2)
    StepX = (X2 - X1) / StepNumber
    StepY = (Y2 - Y1) / StepNumber
    StepZ = (Z2 - Z1) / StepNumber
    For I = 1 To 99
        Call XYZToDecInc(X1 + I * StepX, Y1 + I * StepY, Z1 + I * StepZ, _
            DecPoint, IncPoint)
        If PlotType = 1 Then 'Stereographic Projection as PlotType 1
            RSample = SPlotRadius(Radius, Abs(IncPoint))
        ElseIf PlotType = 2 Then 'Equal Area Projection as PlotType 2
            RSample = EQPlotRadius(Radius, Abs(IncPoint))
        End If
        Call DXDYCalc(DX, DY, RSample, DecPoint)
        Call CurrXY(CurrX, CurrY)
        frmPointsPlot.picPointsPlot.Line -(CurrX, CurrY), LineColor
    Next I
End Sub

'Purpose:   To perform Zijderveld Projection.
Private Sub PointsZPlot(ByVal AxisLength As Single)
    Dim ScaleLength As Single      'Scale Length of one tick mark
    Dim ScaleTwips As Single      'Screen Scale Length (in twips) of one tick mark
    Dim TickNum As Integer              'Number of Tick Marks Needed
    Dim N As Integer                    '
    Dim Range As Single                 'Range of X and Y Data
    Dim HorizontalVector As Double      'Horizontal Component of the Demag Vector
    Dim MinX As Single, MaxX As Single, MinY As Single, MaxY As Single
    Dim I As Integer
    Dim OriginX As Single, OriginY As Single
    Dim DX As Single, DY As Single, CurrDX As Single, CurrDY As Single
    Dim IX As Single, IY As Single, CurrIX As Single, CurrIY As Single
    Dim PrevDX As Single, PrevDY As Single, PrevIX As Single, PrevIY As Single
       
    If IsNumeric(txtDecColorR.Text) = False Or IsNumeric(txtDecColorG.Text) = False Or _
        IsNumeric(txtDecColorB.Text) = False Or IsNumeric(txtIncColorR.Text) = False Or _
        IsNumeric(txtIncColorG.Text) = False Or IsNumeric(txtIncColorB.Text) = False Then
            Call MsgBox("Color values must be Integers!", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    ElseIf (CInt(txtDecColorR.Text) < 0 Or CInt(txtDecColorR.Text) > 255) Or _
        (CInt(txtDecColorG.Text) < 0 Or CInt(txtDecColorG.Text) > 255) Or _
        (CInt(txtDecColorB.Text) < 0 Or CInt(txtDecColorB.Text) > 255) Or _
        (CInt(txtIncColorR.Text) < 0 Or CInt(txtIncColorR.Text) > 255) Or _
        (CInt(txtIncColorG.Text) < 0 Or CInt(txtIncColorG.Text) > 255) Or _
        (CInt(txtIncColorB.Text) < 0 Or CInt(txtIncColorB.Text) > 255) Then
            Call MsgBox("Color values must be in the range 0 to 255", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    End If
    
    If IsNumeric(txtDecSize.Text) = False Then
        Call MsgBox("Symbol size is not a number!", vbOKOnly, "Zijderveld Plot Symbol Size")
        Call txtDecSize.SetFocus
        Exit Sub
    ElseIf CInt(txtDecSize.Text) < 1 Or CInt(txtDecSize.Text) > 100 Then
        Call MsgBox("Symbol size must be an integer (1 to 100)", vbOKOnly, "Zijderveld Plot Symbol Size")
        Call txtDecSize.SetFocus
        Exit Sub
    End If
    
    DecColor = RGB(CInt(txtDecColorR.Text), CInt(txtDecColorG.Text), CInt(txtDecColorB.Text))
    IncColor = RGB(CInt(txtIncColorR.Text), CInt(txtIncColorG.Text), CInt(txtIncColorB.Text))
    ZPlotSymSize = CInt(txtDecSize.Text)
    
    ReDim DecX(1 To PointIndex) As Single, DecY(1 To PointIndex) As Single, _
        IncX(1 To PointIndex) As Single, IncY(1 To PointIndex) As Single
       
    If ModifyYN = True Then   'For Modified Zijderveld Projection: "N" up (same as convention)
        For I = 1 To PointIndex
            'Horizontal Component
            HorizontalVector = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination))
            DecX(I) = HorizontalVector * Sin(DegToRad(Points(I).Declination))
            DecY(I) = -HorizontalVector * Cos(DegToRad(Points(I).Declination))
            'Vertical Component:
            If Plane = -2 Then   'No Projection
                IncX(I) = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination))
            Else    'Projection Plane = RecordHead.Theta
                IncX(I) = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination)) _
                            * Cos(DegToRad(Points(I).Declination - Plane))
            End If
            IncY(I) = Points(I).Intensity * Sin(DegToRad(Points(I).Inclination))
            Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
        Next I
    Else    'For Zijderveld Projection: "N" to the right (conventionally East)
        For I = 1 To PointIndex
            'Horizontal Component
            HorizontalVector = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination))
            DecY(I) = HorizontalVector * Sin(DegToRad(Points(I).Declination))
            DecX(I) = HorizontalVector * Cos(DegToRad(Points(I).Declination))
            'Vertical Component:
            If Plane = -2 Then   'No Projection
                IncX(I) = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination))
            Else    'Projection Plane = RecordHead.Theta
                IncX(I) = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination)) _
                            * Cos(DegToRad(Points(I).Declination - Plane))
            End If
            IncY(I) = Points(I).Intensity * Sin(DegToRad(Points(I).Inclination))
            Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
        Next I
    End If
   
    'Purpose:   To determine number of tick marks needed.
    'Tick mark numbers: minimum - 8, maximum - 20.
    Call FindRange(Range, MinX, MaxX, MinY, MaxY)
    ScaleLength = FindScaleLength(Range)
    TickNum = Int(Range / ScaleLength) + 2
    ScaleTwips = AxisLength / TickNum
    
    'Purpose:   To find the origin on the plot.
    If MinX < 0 Then
        If MaxX < 0 Then
            OriginX = frmPointsPlot.picPointsPlot.ScaleWidth - 1000
        Else
            OriginX = ScaleTwips * (Int(Abs(MinX / ScaleLength)) + 1) + 600
        End If
    Else    'MinX>0
        OriginX = 1000
    End If
    If MinY < 0 Then
        If MaxY < 0 Then
            OriginY = frmPointsPlot.picPointsPlot.ScaleHeight - 1000
        Else
            OriginY = ScaleTwips * (Int(Abs(MinY) / ScaleLength) + 1) + 600
        End If
    Else
        OriginY = 1000
    End If
    
    If ModifyYN = True Then
        Call PointsZPlotAxes_Modified(OriginX, OriginY, ScaleTwips, ScaleLength, Plane, DecColor, IncColor)
    Else
        Call PointsZPlotAxes(OriginX, OriginY, ScaleTwips, ScaleLength, Plane, DecColor, IncColor)
    End If
    
    'Purpose:    To display the points on Zijderveld Plot.
    PrevDX = 100000
    PrevDY = 100000
    PrevIX = 100000
    PrevIY = 100000
    For I = 1 To PointIndex
        DX = DecX(I) / ScaleLength * ScaleTwips
        DY = DecY(I) / ScaleLength * ScaleTwips
        CurrDX = OriginX + DX
        CurrDY = OriginY + DY
        
        IX = IncX(I) / ScaleLength * ScaleTwips
        IY = IncY(I) / ScaleLength * ScaleTwips
        CurrIX = OriginX + IX
        CurrIY = OriginY + IY
        
        If I = 1 Then   'Plot the first point with square symble
            frmPointsPlot.picPointsPlot.Line (CurrDX - 10 * ZPlotSymSize, CurrDY - 10 * ZPlotSymSize)-Step(20 * ZPlotSymSize, 20 * ZPlotSymSize), _
                DecColor, BF
            frmPointsPlot.picPointsPlot.Line (CurrIX - 10 * ZPlotSymSize, CurrIY - 10 * ZPlotSymSize)-Step(20 * ZPlotSymSize, 20 * ZPlotSymSize), _
                IncColor, BF
            PrevDX = CurrDX
            PrevDY = CurrDY
            PrevIX = CurrIX
            PrevIY = CurrIY
        Else
            If PrevDX <> 100000 And PrevDY <> 100000 Then
                frmPointsPlot.picPointsPlot.Line (PrevDX, PrevDY)-(CurrDX, CurrDY), DecColor
            End If
            frmPointsPlot.picPointsPlot.FillStyle = 0
            frmPointsPlot.picPointsPlot.FillColor = DecColor
            frmPointsPlot.picPointsPlot.Circle (CurrDX, CurrDY), 10 * ZPlotSymSize, DecColor
            If PrevIX <> 100000 And PrevIY <> 100000 Then
                frmPointsPlot.picPointsPlot.Line (PrevIX, PrevIY)-(CurrIX, _
                    CurrIY), IncColor
            End If
            frmPointsPlot.picPointsPlot.FillColor = IncColor
            frmPointsPlot.picPointsPlot.Circle (CurrIX, CurrIY), 10 * ZPlotSymSize, IncColor
            PrevDX = CurrDX
            PrevDY = CurrDY
            PrevIX = CurrIX
            PrevIY = CurrIY
        End If
    Next I
End Sub

'Purpose:   To print Zijderveld Projection.
Private Sub PrintPointsZPlot(ByVal AxisLength As Single)
    Dim ScaleLength As Single      'Scale Length of one tick mark
    Dim ScaleTwips As Single      'Screen Scale Length (in twips) of one tick mark
    Dim TickNum As Integer              'Number of Tick Marks Needed
    Dim N As Integer                    '
    Dim Range As Single                 'Range of X and Y Data
    Dim HorizontalVector As Double      'Horizontal Component of the Demag Vector
    Dim MinX As Single, MaxX As Single, MinY As Single, MaxY As Single
    Dim I As Integer
    Dim OriginX As Single, OriginY As Single
    Dim DX As Single, DY As Single, CurrDX As Single, CurrDY As Single
    Dim IX As Single, IY As Single, CurrIX As Single, CurrIY As Single
    Dim PrevDX As Single, PrevDY As Single, PrevIX As Single, PrevIY As Single
       
       
    'Take into account the Printer.Zoom setting
    AxisLength = AxisLength * Printer.Zoom / 100
       
    If IsNumeric(txtDecColorR.Text) = False Or IsNumeric(txtDecColorG.Text) = False Or _
        IsNumeric(txtDecColorB.Text) = False Or IsNumeric(txtIncColorR.Text) = False Or _
        IsNumeric(txtIncColorG.Text) = False Or IsNumeric(txtIncColorB.Text) = False Then
            Call MsgBox("Color values must be Integers!", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    ElseIf (CInt(txtDecColorR.Text) < 0 Or CInt(txtDecColorR.Text) > 255) Or _
        (CInt(txtDecColorG.Text) < 0 Or CInt(txtDecColorG.Text) > 255) Or _
        (CInt(txtDecColorB.Text) < 0 Or CInt(txtDecColorB.Text) > 255) Or _
        (CInt(txtIncColorR.Text) < 0 Or CInt(txtIncColorR.Text) > 255) Or _
        (CInt(txtIncColorG.Text) < 0 Or CInt(txtIncColorG.Text) > 255) Or _
        (CInt(txtIncColorB.Text) < 0 Or CInt(txtIncColorB.Text) > 255) Then
            Call MsgBox("Color values must be in the range 0 to 255", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    End If
    
    If IsNumeric(txtDecSize.Text) = False Then
        Call MsgBox("Symbol size is not a number!", vbOKOnly, "Zijderveld Plot Symbol Size")
        Call txtDecSize.SetFocus
        Exit Sub
    ElseIf CInt(txtDecSize.Text) < 1 Or CInt(txtDecSize.Text) > 100 Then
        Call MsgBox("Symbol size must be an integer (1 to 100)", vbOKOnly, "Zijderveld Plot Symbol Size")
        Call txtDecSize.SetFocus
        Exit Sub
    End If
    
    DecColor = RGB(CInt(txtDecColorR.Text), CInt(txtDecColorG.Text), CInt(txtDecColorB.Text))
    IncColor = RGB(CInt(txtIncColorR.Text), CInt(txtIncColorG.Text), CInt(txtIncColorB.Text))
    ZPlotSymSize = CInt(txtDecSize.Text)
    
    ReDim DecX(1 To PointIndex) As Single, DecY(1 To PointIndex) As Single, _
        IncX(1 To PointIndex) As Single, IncY(1 To PointIndex) As Single
       
    If ModifyYN = True Then   'For Modified Zijderveld Projection: "N" up (same as convention)
        For I = 1 To PointIndex
            'Horizontal Component
            HorizontalVector = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination))
            DecX(I) = HorizontalVector * Sin(DegToRad(Points(I).Declination))
            DecY(I) = -HorizontalVector * Cos(DegToRad(Points(I).Declination))
            'Vertical Component:
            If Plane = -2 Then   'No Projection
                IncX(I) = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination))
            Else    'Projection Plane = RecordHead.Theta
                IncX(I) = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination)) _
                            * Cos(DegToRad(Points(I).Declination - Plane))
            End If
            IncY(I) = Points(I).Intensity * Sin(DegToRad(Points(I).Inclination))
            Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
        Next I
    Else    'For Zijderveld Projection: "N" to the right (conventionally East)
        For I = 1 To PointIndex
            'Horizontal Component
            HorizontalVector = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination))
            DecY(I) = HorizontalVector * Sin(DegToRad(Points(I).Declination))
            DecX(I) = HorizontalVector * Cos(DegToRad(Points(I).Declination))
            'Vertical Component:
            If Plane = -2 Then   'No Projection
                IncX(I) = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination))
            Else    'Projection Plane = RecordHead.Theta
                IncX(I) = Points(I).Intensity * Cos(DegToRad(Points(I).Inclination)) _
                            * Cos(DegToRad(Points(I).Declination - Plane))
            End If
            IncY(I) = Points(I).Intensity * Sin(DegToRad(Points(I).Inclination))
            Call FindMaxMin(MinX, MaxX, MinY, MaxY, DecX(I), DecY(I), IncX(I), IncY(I))
        Next I
    End If
   
    'Purpose:   To determine number of tick marks needed.
    'Tick mark numbers: minimum - 8, maximum - 20.
    Call FindRange(Range, MinX, MaxX, MinY, MaxY)
    ScaleLength = FindScaleLength(Range)
    TickNum = Int(Range / ScaleLength) + 2
    ScaleTwips = AxisLength / TickNum
        
    'Take into account the printer zoom setting
    ScaleTwips = ScaleTwips * Printer.Zoom / 100
    
        'Purpose:   To find the origin on the plot.
        If MinX < 0 Then
            If MaxX < 0 Then
                OriginX = ScaleTwips * TickNum + 720
            Else
                OriginX = ScaleTwips * (Int(Abs(MinX / ScaleLength)) + 1) + 2160
            End If
        Else    'MinX>0
            OriginX = 2160
        End If
        If MinY < 0 Then
            If MaxY < 0 Then
                OriginY = ScaleTwips * TickNum + 2880
            Else
                OriginY = ScaleTwips * (Int(Abs(MinY / ScaleLength)) + 1) + 2160
            End If
        Else
            OriginY = 2160
        End If

    If ModifyYN = True Then
        Call PrintPointsZPlotAxes_Modified(OriginX, OriginY, ScaleTwips, ScaleLength, Plane, DecColor, IncColor, TickNum)
    Else
        Call PrintPointsZPlotAxes(OriginX, OriginY, ScaleTwips, ScaleLength, Plane, DecColor, IncColor, TickNum)
    End If
    
    'Purpose:    To display the points on Zijderveld Plot.
    PrevDX = 100000
    PrevDY = 100000
    PrevIX = 100000
    PrevIY = 100000
    For I = 1 To PointIndex
        DX = DecX(I) / ScaleLength * ScaleTwips
        DY = DecY(I) / ScaleLength * ScaleTwips
        CurrDX = OriginX + DX
        CurrDY = OriginY + DY
        
        IX = IncX(I) / ScaleLength * ScaleTwips
        IY = IncY(I) / ScaleLength * ScaleTwips
        CurrIX = OriginX + IX
        CurrIY = OriginY + IY
        
        If I = 1 Then   'Plot the first point with square symble
            Printer.Line (CurrDX - 10 * ZPlotSymSize, CurrDY - 10 * ZPlotSymSize)-Step(20 * ZPlotSymSize, 20 * ZPlotSymSize), _
                DecColor, BF
            Printer.Line (CurrIX - 10 * ZPlotSymSize, CurrIY - 10 * ZPlotSymSize)-Step(20 * ZPlotSymSize, 20 * ZPlotSymSize), _
                IncColor, BF
            PrevDX = CurrDX
            PrevDY = CurrDY
            PrevIX = CurrIX
            PrevIY = CurrIY
        Else
            If PrevDX <> 100000 And PrevDY <> 100000 Then
                Printer.Line (PrevDX, PrevDY)-(CurrDX, CurrDY), DecColor
            End If
            Printer.FillStyle = 0
            Printer.FillColor = DecColor
            Printer.Circle (CurrDX, CurrDY), 10 * ZPlotSymSize, DecColor
            If PrevIX <> 100000 And PrevIY <> 100000 Then
                Printer.Line (PrevIX, PrevIY)-(CurrIX, _
                    CurrIY), IncColor
            End If
            Printer.FillColor = IncColor
            Printer.Circle (CurrIX, CurrIY), 10 * ZPlotSymSize, IncColor
            PrevDX = CurrDX
            PrevDY = CurrDY
            PrevIX = CurrIX
            PrevIY = CurrIY
        End If
    Next I
End Sub

'Purpose:   To display the background of Stereographic projection.
Private Sub PrintSPlotBackground(ByVal Radius As Single)
    Dim Inclination As Single
    Dim Theta As Single
     
    'Take into account the Printer.Zoom setting
    Radius = Radius * Printer.Zoom / 100
    
    CenterX = Printer.ScaleWidth / 2
    CenterY = Printer.ScaleHeight / 2
    
    Printer.FillStyle = 1
    Printer.Circle (CenterX, CenterY), Radius
    For Inclination = 10 To 80 Step 10
        Printer.Circle (CenterX, CenterY), SPlotRadius(Radius, Inclination)
    Next Inclination
    For Theta = 0 To 170 Step 10
        Printer.Line (CenterX + Radius * Cos(DegToRad(Theta)), _
            CenterY + Radius * Sin(DegToRad(Theta)))- _
            (CenterX - Radius * Cos(DegToRad(Theta)), _
            CenterY - Radius * Sin(DegToRad(Theta)))
    Next Theta
    Printer.CurrentX = CenterX - 100
    Printer.CurrentY = CenterY - Radius - 240
    Printer.Print "N"
    Printer.CurrentX = CenterX + Radius + 40
    Printer.CurrentY = CenterY - 120
    Printer.Print "E"
    Printer.CurrentX = CenterX - 100
    Printer.CurrentY = CenterY + Radius + 30
    Printer.Print "S"
    Printer.CurrentX = CenterX - Radius - 220
    Printer.CurrentY = CenterY - 120
    Printer.Print "W"
End Sub

'Purpose:   To display data using Stereographic projection.
Private Sub PrintSPlotDisplay(ByVal Radius As Single)
    Dim Counter As Long, PrevCounter As Long
    
    'Take into account the Printer.Zoom setting
    Radius = Radius * Printer.Zoom / 100
    
    PrevCounter = 0
    
    If IsNumeric(txtSymColorR.Text) = False Or IsNumeric(txtSymColorG.Text) = False Or _
        IsNumeric(txtSymColorB.Text) = False Or IsNumeric(txtLineColorR.Text) = False Or _
        IsNumeric(txtLineColorG.Text) = False Or IsNumeric(txtLineColorB.Text) = False Then
            Call MsgBox("Color values must be Integers!", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    ElseIf (CInt(txtSymColorR.Text) < 0 Or CInt(txtSymColorR.Text) > 255) Or _
        (CInt(txtSymColorG.Text) < 0 Or CInt(txtSymColorG.Text) > 255) Or _
        (CInt(txtSymColorB.Text) < 0 Or CInt(txtSymColorB.Text) > 255) Or _
        (CInt(txtLineColorR.Text) < 0 Or CInt(txtLineColorR.Text) > 255) Or _
        (CInt(txtLineColorG.Text) < 0 Or CInt(txtLineColorG.Text) > 255) Or _
        (CInt(txtLineColorB.Text) < 0 Or CInt(txtLineColorB.Text) > 255) Then
            Call MsgBox("Color values must be in the range 0 to 255", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    End If
    
    If IsNumeric(txtSymSize.Text) = False Then
        Call MsgBox("Symbol size is not a number!", vbOKOnly, "Stereographic Plot Symbol Size")
        Call txtSymSize.SetFocus
        Exit Sub
    ElseIf CInt(txtSymSize.Text) < 1 Or CInt(txtSymSize.Text) > 100 Then
        Call MsgBox("Symbol size must be an integer (1 to 100)", vbOKOnly, "Stereographic Plot Symbol Size")
        Call txtSymSize.SetFocus
        Exit Sub
    End If
    
    SymbolColor = RGB(CInt(txtSymColorR.Text), CInt(txtSymColorG.Text), CInt(txtSymColorB.Text))
    LineColor = RGB(CInt(txtLineColorR.Text), CInt(txtLineColorG.Text), CInt(txtLineColorB.Text))
    SPlotSymSize = CInt(txtSymSize.Text)
    
    If Connect = True Then
        For Counter = 1 To PointIndex
            RSample = SPlotRadius(Radius, Abs(Points(Counter).Inclination))
            Call DXDYCalc(DX, DY, RSample, Points(Counter).Declination)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Points(1).Inclination < 0 Then
                    Printer.Line (CurrX - 10 * SPlotSymSize, CurrY - 10 * SPlotSymSize)-Step(20 * SPlotSymSize, 20 * SPlotSymSize), SymbolColor, B
                Else
                    Printer.Line (CurrX - 10 * SPlotSymSize, CurrY - 10 * SPlotSymSize)-Step(20 * SPlotSymSize, 20 * SPlotSymSize), SymbolColor, BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call PrintConnectPoints(Radius, Points(PrevCounter).Declination, _
                        Points(PrevCounter).Inclination, Points(Counter).Declination, Points(Counter).Inclination, 1)
                    Printer.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), _
                        LineColor
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Points(Counter).Inclination < 0 Then
                    Printer.Circle (CurrX, CurrY), 10 * SPlotSymSize, SymbolColor
                Else
                    Printer.FillStyle = 0
                    Printer.FillColor = SymbolColor
                    Printer.Circle (CurrX, CurrY), 10 * SPlotSymSize, SymbolColor
                    Printer.FillStyle = 1
                    Printer.FillColor = Printer.ForeColor
                End If
            End If
        Next Counter
    Else
        For Counter = 1 To PointIndex
            RSample = SPlotRadius(Radius, Abs(Points(Counter).Inclination))
            Call DXDYCalc(DX, DY, RSample, Points(Counter).Declination)
            Call CurrXY(CurrX, CurrY)
            If Points(Counter).Inclination < 0 Then
                Printer.Circle (CurrX, CurrY), 10 * SPlotSymSize, SymbolColor
            Else
                Printer.FillStyle = 0
                Printer.FillColor = SymbolColor
                Printer.Circle (CurrX, CurrY), 10 * SPlotSymSize, SymbolColor
                Printer.FillStyle = 1
                Printer.FillColor = Printer.ForeColor
            End If
        Next Counter
    End If
End Sub

'Purpose:   To connect two points in Stereographic Projection or
'           Lambert Equal-area Projection
'Radius:    Radius of the projection circle.
'AngleDec1 & AngleDec2: Declination of the first and second points.
'AngleInc1 & AngleInc2: Inclination of the first and second points.
Private Sub PrintConnectPoints(ByVal Radius As Single, _
    ByVal AngleDec1 As Single, ByVal AngleInc1 As Single, _
    ByVal AngleDec2 As Single, ByVal AngleInc2 As Single, ByVal PlotType As Integer)
       
    Dim I As Integer, StepNumber As Integer
    Dim X1 As Single, Y1 As Single, Z1 As Single
    Dim X2 As Single, Y2 As Single, Z2 As Single
    Dim StepX As Single, StepY As Single, StepZ As Single
    Dim DecPoint As Single, IncPoint As Single
    
    
    Call XYZFromDecInc(X1, Y1, Z1, Radius, AngleDec1, AngleInc1)
    Call XYZFromDecInc(X2, Y2, Z2, Radius, AngleDec2, AngleInc2)
    StepNumber = 1000         'Number of Steps from (X1, Y1, Z1) to (X2, Y2, Z2)
    StepX = (X2 - X1) / StepNumber
    StepY = (Y2 - Y1) / StepNumber
    StepZ = (Z2 - Z1) / StepNumber
    For I = 1 To 999
        Call XYZToDecInc(X1 + I * StepX, Y1 + I * StepY, Z1 + I * StepZ, _
            DecPoint, IncPoint)
        If PlotType = 1 Then 'Stereographic Projection as PlotType 1
            RSample = SPlotRadius(Radius, Abs(IncPoint))
        ElseIf PlotType = 2 Then 'Equal Area Projection as PlotType 2
            RSample = EQPlotRadius(Radius, Abs(IncPoint))
        End If
        Call DXDYCalc(DX, DY, RSample, DecPoint)
        Call CurrXY(CurrX, CurrY)
        Printer.Line -(CurrX, CurrY), LineColor
    Next I
End Sub

'Purpose:   To print the background of Lambert Equal-area projection.
Private Sub PrintEQPlotBackground(ByVal Radius As Single)
    Dim Inclination As Single
    Dim Theta As Single
    
    'Take into account the Printer.Zoom setting
    Radius = Radius * Printer.Zoom / 100
    
    CenterX = Printer.ScaleWidth / 2
    CenterY = Printer.ScaleHeight / 2
    
    Printer.FillStyle = 1
    Printer.Circle (CenterX, CenterY), Radius
    For Inclination = 10 To 80 Step 10
        Printer.Circle (CenterX, CenterY), EQPlotRadius(Radius, Inclination)
    Next Inclination
    For Theta = 0 To 170 Step 10
        Printer.Line (CenterX + Radius * Cos(DegToRad(Theta)), _
            CenterY + Radius * Sin(DegToRad(Theta)))- _
            (CenterX - Radius * Cos(DegToRad(Theta)), _
            CenterY - Radius * Sin(DegToRad(Theta)))
    Next Theta
    Printer.CurrentX = CenterX - 100
    Printer.CurrentY = CenterY - Radius - 240
    Printer.Print "N"
    Printer.CurrentX = CenterX + Radius + 40
    Printer.CurrentY = CenterY - 120
    Printer.Print "E"
    Printer.CurrentX = CenterX - 100
    Printer.CurrentY = CenterY + Radius + 30
    Printer.Print "S"
    Printer.CurrentX = CenterX - Radius - 220
    Printer.CurrentY = CenterY - 120
    Printer.Print "W"
End Sub

'Purpose:   To print data using Lambert Equal-area projection.
Private Sub PrintEQPlotDisplay(ByVal Radius As Single)
    Dim Counter As Long, PrevCounter As Long
    
    'Take into account the Printer.Zoom setting
    Radius = Radius * Printer.Zoom / 100
    
    PrevCounter = 0
    
    If IsNumeric(txtSymColorR.Text) = False Or IsNumeric(txtSymColorG.Text) = False Or _
        IsNumeric(txtSymColorB.Text) = False Or IsNumeric(txtLineColorR.Text) = False Or _
        IsNumeric(txtLineColorG.Text) = False Or IsNumeric(txtLineColorB.Text) = False Then
            Call MsgBox("Color values must be Integers!", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    ElseIf (CInt(txtSymColorR.Text) < 0 Or CInt(txtSymColorR.Text) > 255) Or _
        (CInt(txtSymColorG.Text) < 0 Or CInt(txtSymColorG.Text) > 255) Or _
        (CInt(txtSymColorB.Text) < 0 Or CInt(txtSymColorB.Text) > 255) Or _
        (CInt(txtLineColorR.Text) < 0 Or CInt(txtLineColorR.Text) > 255) Or _
        (CInt(txtLineColorG.Text) < 0 Or CInt(txtLineColorG.Text) > 255) Or _
        (CInt(txtLineColorB.Text) < 0 Or CInt(txtLineColorB.Text) > 255) Then
            Call MsgBox("Color values must be in the range 0 to 255", vbOKOnly, "Color (0 to 255)")
            Exit Sub
    End If
    
    If IsNumeric(txtSymSize.Text) = False Then
        Call MsgBox("Symbol size is not a number!", vbOKOnly, "Equal Area Plot Symbol Size")
        Call txtSymSize.SetFocus
        Exit Sub
    ElseIf CInt(txtSymSize.Text) < 1 Or CInt(txtSymSize.Text) > 100 Then
        Call MsgBox("Symbol size must be an integer (1 to 100)", vbOKOnly, "Equal Area Plot Symbol Size")
        Call txtSymSize.SetFocus
        Exit Sub
    End If
    
    SymbolColor = RGB(CInt(txtSymColorR.Text), CInt(txtSymColorG.Text), CInt(txtSymColorB.Text))
    LineColor = RGB(CInt(txtLineColorR.Text), CInt(txtLineColorG.Text), CInt(txtLineColorB.Text))
    SPlotSymSize = CInt(txtSymSize.Text)

    If Connect = True Then
        For Counter = 1 To PointIndex
            RSample = EQPlotRadius(Radius, Abs(Points(Counter).Inclination))
            Call DXDYCalc(DX, DY, RSample, Points(Counter).Declination)
            If Counter = 1 Then
                Call CurrXY(CurrX, CurrY)
                If Points(1).Inclination < 0 Then
                    Printer.Line (CurrX - SPlotSymSize * 10, CurrY - SPlotSymSize * 10)-Step(SPlotSymSize * 20, SPlotSymSize * 20), SymbolColor, B
                Else
                    Printer.Line (CurrX - SPlotSymSize * 10, CurrY - SPlotSymSize * 10)-Step(SPlotSymSize * 20, SPlotSymSize * 20), SymbolColor, BF
                End If
                PrevCounter = Counter
            Else
                If PrevCounter <> 0 Then
                    Call PrintConnectPoints(Radius, Points(PrevCounter).Declination, _
                        Points(PrevCounter).Inclination, Points(Counter).Declination, Points(Counter).Inclination, 2)
                    Printer.Line (CurrX, CurrY)-(CenterX + DX, CenterY - DY), _
                        LineColor
                End If
                PrevCounter = Counter
                Call CurrXY(CurrX, CurrY)
                If Points(Counter).Inclination < 0 Then
                    Printer.Circle (CurrX, CurrY), SPlotSymSize * 10, SymbolColor
                Else
                    Printer.FillStyle = 0
                    Printer.FillColor = SymbolColor
                    Printer.Circle (CurrX, CurrY), SPlotSymSize * 10, SymbolColor
                    Printer.FillStyle = 1
                    Printer.FillColor = Printer.ForeColor
                End If
            End If
        Next Counter
    Else
        For Counter = 1 To PointIndex
            RSample = EQPlotRadius(Radius, Abs(Points(Counter).Inclination))
            Call DXDYCalc(DX, DY, RSample, Points(Counter).Declination)
            Call CurrXY(CurrX, CurrY)
            If Points(Counter).Inclination < 0 Then
                Printer.Circle (CurrX, CurrY), SPlotSymSize * 10, SymbolColor
            Else
                Printer.FillStyle = 0
                Printer.FillColor = SymbolColor
                Printer.Circle (CurrX, CurrY), SPlotSymSize * 10, SymbolColor
                Printer.FillStyle = 1
                Printer.FillColor = Printer.ForeColor
            End If
        Next Counter
    End If
End Sub

'All Angles passed from other subroutines are in radian
'PlotType: 1 = Stereographic, 2 = Lambert Equal Area
Private Sub EllipsePlotSub(ByVal NumPoints As Long, ByVal Latitude As Single, ByVal Longitude As Single, _
    ByVal Declination As Single, ByVal Inclination As Single, ByVal Alpha95 As Single, _
    ByVal AxisLength As Single, ByVal SPlotSymSize As Single, ByVal SymbolColor As ColorConstants, _
    ByVal LineThickness As Single, ByVal LineColor As ColorConstants, _
    ByVal PlotSampleCIrcleYN As Boolean, ByVal PlotType As Integer)
    
    Dim Theta As Single, RSample As Single, I As Long
    Dim CurrentInc As Single, CurrentDec As Single
    Dim Alpha As Single, Beta As Single, Gamma As Single, A As Single, B As Single, COSAlpha As Single
    'Alpha = Co_lat of inclination of moving points, Beta = Alpha95 (error), Gamma = Co_Lat of mean inclination
    'A = PI/2 - Theta (Angle between the moving arm of error and the longitude (Declination) of the mean
    'B = Deltaphi (change in declination/longitude), COSAlpha = cos(Alpha)
    Dim VGPLat As Single, VGPLong As Single
    
    'Plot Center of VGP
    Call VGPFromSite(Declination, Inclination, Latitude, Longitude, VGPLat, VGPLong)
    If PlotType = 1 Then
        RSample = SPlotRadius(AxisLength / 2, Abs(VGPLat))
    Else
        RSample = EQPlotRadius(AxisLength / 2, Abs(VGPLat))
    End If
    Call DXDYCalc(DX, DY, RSample, VGPLong)
    Call CurrXY(CurrX, CurrY)
    frmPointsPlot.picPointsPlot.FillStyle = 0
    frmPointsPlot.picPointsPlot.FillColor = SymbolColor
    frmPointsPlot.picPointsPlot.Circle (CurrX, CurrY), 10 * SPlotSymSize, SymbolColor
      
    If MsgBox("Plot sample site location as a Red Square?", vbYesNo) = vbYes Then
        If PlotType = 1 Then
            RSample = SPlotRadius(AxisLength / 2, Abs(RadToDeg(Latitude)))
        Else
            RSample = EQPlotRadius(AxisLength / 2, Abs(RadToDeg(Latitude)))
        End If
        Call DXDYCalc(DX, DY, RSample, RadToDeg(Longitude))
        Call CurrXY(CurrX, CurrY)
        frmPointsPlot.picPointsPlot.Line (CurrX - 30, CurrY - 30)-(CurrX + 30, CurrY + 30), RGB(255, 0, 0), BF
    End If
      
    frmPointsPlot.picPointsPlot.FillColor = LineColor
    
    Gamma = PI / 2 - Inclination
    Beta = Alpha95
    
    For I = 0 To NumPoints
        Theta = 2 * I * PI / NumPoints 'Rotation angle about the Mean
        A = PI / 2 - Theta
        COSAlpha = Cos(Beta) * Cos(Gamma) + Sin(Beta) * Sin(Gamma) * Cos(A)
        Alpha = ArcCos(COSAlpha)
        CurrentInc = PI / 2 - Alpha
        If Abs(COSAlpha) < 1 Then
            B = ArcSin(Sin(Beta) * Sin(A) / Sqr(1 - COSAlpha ^ 2))
        Else
            B = 0
        End If
        
        If Cos(Beta) >= Cos(Gamma) * Cos(Alpha) Then
            CurrentDec = Declination + B
        Else
            CurrentDec = Declination + PI - B
        End If
        
        If PlotSampleCIrcleYN = True Then
            If PlotType = 1 Then
                RSample = SPlotRadius(AxisLength / 2, Abs(RadToDeg(CurrentInc)))
            Else
                RSample = EQPlotRadius(AxisLength / 2, Abs(RadToDeg(CurrentInc)))
            End If
            Call DXDYCalc(DX, DY, RSample, RadToDeg(CurrentDec))
            Call CurrXY(CurrX, CurrY)
            frmPointsPlot.picPointsPlot.Circle (CurrX, CurrY), 4 * LineThickness, LineColor
        End If

        Call VGPFromSite(CurrentDec, CurrentInc, Latitude, Longitude, VGPLat, VGPLong)
            If PlotType = 1 Then
                RSample = SPlotRadius(AxisLength / 2, Abs(VGPLat))
            Else
                RSample = EQPlotRadius(AxisLength / 2, Abs(VGPLat))
            End If
        Call DXDYCalc(DX, DY, RSample, VGPLong)
        Call CurrXY(CurrX, CurrY)

        frmPointsPlot.picPointsPlot.Circle (CurrX, CurrY), 4 * LineThickness, LineColor
    Next I
End Sub

'All Angles passed from other subroutines are in radian
'PlotType: 1 = Stereographic, 2 = Lambert Equal Area
Private Sub EllipsePrintSub(ByVal NumPoints As Long, ByVal Latitude As Single, ByVal Longitude As Single, _
    ByVal Declination As Single, ByVal Inclination As Single, ByVal Alpha95 As Single, _
    ByVal AxisLength As Single, ByVal SPlotSymSize As Single, ByVal SymbolColor As ColorConstants, _
    ByVal LineThickness As Single, ByVal LineColor As ColorConstants, _
    ByVal PlotSampleCIrcleYN As Boolean, ByVal PlotType As Integer)
    
    Dim Theta As Single, RSample As Single, I As Long
    Dim CurrentInc As Single, CurrentDec As Single
    Dim Alpha As Single, Beta As Single, Gamma As Single, A As Single, B As Single, COSAlpha As Single
    'Alpha = Co_lat of inclination of moving points, Beta = Alpha95 (error), Gamma = Co_Lat of mean inclination
    'A = PI/2 - Theta (Angle between the moving arm of error and the longitude (Declination) of the mean
    'B = Deltaphi (change in declination/longitude), COSAlpha = cos(Alpha)
    Dim VGPLat As Single, VGPLong As Single
    
    'Plot Center of VGP
    Call VGPFromSite(Declination, Inclination, Latitude, Longitude, VGPLat, VGPLong)
    If PlotType = 1 Then
        RSample = SPlotRadius(AxisLength / 2, Abs(VGPLat))
    Else
        RSample = EQPlotRadius(AxisLength / 2, Abs(VGPLat))
    End If
    Call DXDYCalc(DX, DY, RSample, VGPLong)
    Call CurrXY(CurrX, CurrY)
    Printer.FillStyle = 0
    Printer.FillColor = SymbolColor
    Printer.Circle (CurrX, CurrY), 10 * SPlotSymSize, SymbolColor
      
    If MsgBox("Plot sample site location as a Red Square?", vbYesNo) = vbYes Then
        If PlotType = 1 Then
            RSample = SPlotRadius(AxisLength / 2, Abs(RadToDeg(Latitude)))
        Else
            RSample = EQPlotRadius(AxisLength / 2, Abs(RadToDeg(Latitude)))
        End If
        Call DXDYCalc(DX, DY, RSample, RadToDeg(Longitude))
        Call CurrXY(CurrX, CurrY)
        Printer.Line (CurrX - 30, CurrY - 30)-(CurrX + 30, CurrY + 30), RGB(255, 0, 0), BF
    End If
      
    Printer.FillColor = LineColor
    
    Gamma = PI / 2 - Inclination
    Beta = Alpha95
    
    For I = 0 To NumPoints
        Theta = 2 * I * PI / NumPoints 'Rotation angle about the Mean
        A = PI / 2 - Theta
        COSAlpha = Cos(Beta) * Cos(Gamma) + Sin(Beta) * Sin(Gamma) * Cos(A)
        Alpha = ArcCos(COSAlpha)
        CurrentInc = PI / 2 - Alpha
        If Abs(COSAlpha) < 1 Then
            B = ArcSin(Sin(Beta) * Sin(A) / Sqr(1 - COSAlpha ^ 2))
        Else
            B = 0
        End If
        
        If Cos(Beta) >= Cos(Gamma) * Cos(Alpha) Then
            CurrentDec = Declination + B
        Else
            CurrentDec = Declination + PI - B
        End If
        
        If PlotSampleCIrcleYN = True Then
            If PlotType = 1 Then
                RSample = SPlotRadius(AxisLength / 2, Abs(RadToDeg(CurrentInc)))
            Else
                RSample = EQPlotRadius(AxisLength / 2, Abs(RadToDeg(CurrentInc)))
            End If
            Call DXDYCalc(DX, DY, RSample, RadToDeg(CurrentDec))
            Call CurrXY(CurrX, CurrY)
            Printer.Circle (CurrX, CurrY), 4 * LineThickness, LineColor
        End If

        Call VGPFromSite(CurrentDec, CurrentInc, Latitude, Longitude, VGPLat, VGPLong)
            If PlotType = 1 Then
                RSample = SPlotRadius(AxisLength / 2, Abs(VGPLat))
            Else
                RSample = EQPlotRadius(AxisLength / 2, Abs(VGPLat))
            End If
        Call DXDYCalc(DX, DY, RSample, VGPLong)
        Call CurrXY(CurrX, CurrY)

        Printer.Circle (CurrX, CurrY), 4 * LineThickness, LineColor
    Next I
End Sub

Private Sub GetEllipseInput(ByRef Diameter As Single, ByRef SymbolColor As ColorConstants, _
    ByRef LineColor As ColorConstants, ByRef SPlotSymSize As Integer, _
    ByRef Latitude As Single, ByRef Longitude As Single, ByRef NumPoints As Long, ByRef LineThickness As Single, _
    ByRef Declination As Single, ByRef Inclination As Single, ByRef Alpha95 As Single)
    If IsNumeric(txtDiameter.Text) = True Then
        Diameter = CSng(txtDiameter.Text)
    Else
        Diameter = 15
    End If
    
    'Read Symbol and Line color, size etc.
    If IsNumeric(txtSymColorR.Text) = False Or IsNumeric(txtSymColorG.Text) = False Or _
        IsNumeric(txtSymColorB.Text) = False Or IsNumeric(txtLineColorR.Text) = False Or _
        IsNumeric(txtLineColorG.Text) = False Or IsNumeric(txtLineColorB.Text) = False Then
            Call MsgBox("Color values must be Integers!", vbOKOnly, "Color (0 to 255)")
            InputCorrect = False
            Exit Sub
    ElseIf (CInt(txtSymColorR.Text) < 0 Or CInt(txtSymColorR.Text) > 255) Or _
        (CInt(txtSymColorG.Text) < 0 Or CInt(txtSymColorG.Text) > 255) Or _
        (CInt(txtSymColorB.Text) < 0 Or CInt(txtSymColorB.Text) > 255) Or _
        (CInt(txtLineColorR.Text) < 0 Or CInt(txtLineColorR.Text) > 255) Or _
        (CInt(txtLineColorG.Text) < 0 Or CInt(txtLineColorG.Text) > 255) Or _
        (CInt(txtLineColorB.Text) < 0 Or CInt(txtLineColorB.Text) > 255) Then
            Call MsgBox("Color values must be in the range 0 to 255", vbOKOnly, "Color (0 to 255)")
            InputCorrect = False
            Exit Sub
    End If
    
    If IsNumeric(txtSymSize.Text) = False Then
        Call MsgBox("Symbol size is not a number!", vbOKOnly, "Stereographic Plot Symbol Size")
        Call txtSymSize.SetFocus
        InputCorrect = False
        Exit Sub
    ElseIf CInt(txtSymSize.Text) < 1 Or CInt(txtSymSize.Text) > 100 Then
        Call MsgBox("Symbol size must be an integer (1 to 100)", vbOKOnly, "Stereographic Plot Symbol Size")
        Call txtSymSize.SetFocus
        InputCorrect = False
        Exit Sub
    End If
    
    SymbolColor = RGB(CInt(txtSymColorR.Text), CInt(txtSymColorG.Text), CInt(txtSymColorB.Text))
    LineColor = RGB(CInt(txtLineColorR.Text), CInt(txtLineColorG.Text), CInt(txtLineColorB.Text))
    SPlotSymSize = CInt(txtSymSize.Text)
    
    'Read Data
    If IsNumeric(txtLat.Text) = False Or IsNumeric(txtLong.Text) = False Or _
        IsNumeric(txtLineThickness.Text) = False Then
        Call MsgBox("The Latitude, Longitude, and Line Thickness must all be numbers!", vbOKOnly, "Numeric Values Required")
        Call txtLat.SetFocus
        InputCorrect = False
        Exit Sub
    End If

    Latitude = DegToRad(CSng(txtLat.Text))
    Longitude = DegToRad(CSng(txtLong.Text))
    LineThickness = Abs(CSng(txtLineThickness.Text))
    
    If IsNumeric(txtNumPoints.Text) = False Then
        Call MsgBox("The number of points on the ellipse must be a Number!", vbOKOnly, "Numeric Values Required")
        Call txtNumPoints.SetFocus
        InputCorrect = False
        Exit Sub
    End If
    
    NumPoints = CLng(txtNumPoints.Text)
    
    If IsNumeric(txtFisherDec.Text) = False Or IsNumeric(txtFisherInc.Text) = False Or _
        IsNumeric(txtAlpha95.Text) = False Then
        Call MsgBox("The mean Declination and Inclination, and Alpha95 in Fisher Analysis must all be numbers!", vbOKOnly, "Numeric Values Required")
        Call txtFisherDec.SetFocus
        InputCorrect = False
        Exit Sub
    End If
    
    Declination = DegToRad(CSng(txtFisherDec.Text))
    Inclination = DegToRad(CSng(txtFisherInc.Text))
    Alpha95 = DegToRad(CSng(txtAlpha95.Text))
End Sub

'PlotType: 1 = Stereographic, 2 = Lambert Equal Area
Private Sub ResizePlotArea(ByVal Diameter As Single, ByRef AxisLength As Single, ByVal PlotType As Integer)
    AxisLength = 1440 * Diameter / 2.54

    frmPointsPlot.Height = AxisLength + 1230
    frmPointsPlot.Width = AxisLength + 900
    frmPointsPlot.picPointsPlot.Height = AxisLength + 600
    frmPointsPlot.picPointsPlot.Width = AxisLength + 600
    If PlotType = 1 Then
        frmPointsPlot.Caption = "Stereographic Projection"
    Else
        frmPointsPlot.Caption = "Lambert Equal Area Projection"
    End If
End Sub

'PlotType: 1 = Zijderveld Projection, 2 = Modified Zijderveld Projection
Private Sub ResizeZPlotArea(ByVal Diameter As Single, ByRef AxisLength As Single, ByVal PlotType As Integer)
    AxisLength = 1440 * Diameter / 2.54

    frmPointsPlot.Height = AxisLength + 1230
    frmPointsPlot.Width = AxisLength + 900
    frmPointsPlot.picPointsPlot.Height = AxisLength + 600
    frmPointsPlot.picPointsPlot.Width = AxisLength + 600
    If PlotType = 1 Then
        frmPointsPlot.Caption = "Zijderveld Projection"
    Else
        frmPointsPlot.Caption = "Modified Zijderveld Projection"
    End If
End Sub

'To get information of projections: Connect points or not, Diameter of projection
Private Sub GetPlotInfo(ByRef Diameter As Single)
    If UCase(txtConnect.Text) <> "NO" Then
        Connect = True
    Else
        Connect = False
    End If
    
    If IsNumeric(txtDiameter.Text) = True Then
        Diameter = CSng(txtDiameter.Text)
    Else
        Diameter = 15
    End If
End Sub

Private Sub GetZPlotInfo(ByRef Length As Single)
    If IsNumeric(txtPlane.Text) = True Then
        Plane = CSng(txtPlane.Text)
        If Plane < 0 Then
            Plane = -2
        End If
    Else
        Plane = 0
    End If
    
    If IsNumeric(txtLength.Text) = True Then
        Length = CSng(txtLength.Text)
    Else
        Length = 15
    End If
End Sub

